//
//  DropboxViewController.m
//  Power HTML
//
//  Created by xrm on 13-6-22.
//  Copyright (c) 2013年 XuRuomeng. All rights reserved.
//

#import "DropboxViewController.h"

@interface DropboxViewController ()

@end

@implementation DropboxViewController
@synthesize tableView = dropboxTable;
@synthesize folders;
@synthesize restClient;
@synthesize oldPath;
@synthesize nowPath;
@synthesize paths;
@synthesize meta;
@synthesize loadFile;
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        
    }
    return self;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return [self.folders count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *CustomCellIdentifier = @"DropboxCell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CustomCellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CustomCellIdentifier];
    }
    cell.textLabel.text = [self.folders objectAtIndex:indexPath.row];
    if ([[self.meta objectAtIndex:indexPath.row] isEqualToString:@"0B"]) {
        cell.detailTextLabel.text = @"";
    }else{
        cell.detailTextLabel.text = [self.meta objectAtIndex:indexPath.row];
    }
    
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
	return 64;
}

- (void)setNotification{
    [[NSNotificationCenter defaultCenter]
     addObserver:self selector:@selector(getOutFromDropboxView) name:@"getOutFromDropboxView" object:nil];
}

-(void) viewWillDisappear:(BOOL)animated
{
    if ([self.navigationController.viewControllers indexOfObject:self]==NSNotFound)
    {
        // back button was pressed.  We know this is true because self is no longer
        // in the navigation stack.
        [[NSNotificationCenter defaultCenter] postNotificationName:@"getOutFromDropbox" object:nil];
        [[NSNotificationCenter defaultCenter] postNotificationName:@"savedFromDropbox" object:nil];
    }
    [super viewWillDisappear:animated];
}

-(void)getOutFromDropboxView{
    [self dismissViewControllerAnimated:YES completion:nil];
}

- (void)setInitFolders{
    self.folders = [[NSMutableArray alloc] init];
    self.paths = [[NSMutableArray alloc] init];
    self.meta = [[NSMutableArray alloc] init];
}

- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath{
    return YES;
}

- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        SIAlertView *alert;
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"您确定要删除吗"];
            [alert addButtonWithTitle:@"是的" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
                [[self restClient] deletePath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],[[[tableView cellForRowAtIndexPath:indexPath] textLabel] text]]];
                [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
                if ([[HTMLData language]hasPrefix:@"zh"]) {
                    [SVProgressHUD showWithStatus:@"操作中" maskType:SVProgressHUDMaskTypeClear];
                }else{
                    [SVProgressHUD showWithStatus:@"Deleting..." maskType:SVProgressHUDMaskTypeClear];
                }
            }];
            [alert addButtonWithTitle:@"取消" type:SIAlertViewButtonTypeDestructive handler:nil];
            [alert show];
        }else{
            alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"Sure to delete?"];
            [alert addButtonWithTitle:@"Yes" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
                [[self restClient] deletePath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],[[[tableView cellForRowAtIndexPath:indexPath] textLabel] text]]];
                [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
                if ([[HTMLData language]hasPrefix:@"zh"]) {
                    [SVProgressHUD showWithStatus:@"操作中" maskType:SVProgressHUDMaskTypeClear];
                }else{
                    [SVProgressHUD showWithStatus:@"Deleting..." maskType:SVProgressHUDMaskTypeClear];
                }
            }];
            [alert addButtonWithTitle:@"Cancel" type:SIAlertViewButtonTypeDestructive handler:nil];
            [alert show];
        }
    }
}

- (void)restClient:(DBRestClient *)client deletedPath:(NSString *)path{
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];

    if ([[HTMLData language]hasPrefix:@"zh"]) {
        [SVProgressHUD showSuccessWithStatus:@"删除成功" duration:1];
    }else{
        [SVProgressHUD showSuccessWithStatus:@"Succeeded" duration:1];
    }
    [self refresh];
}

- (void)restClient:(DBRestClient*)client deletePathFailedWithError:(NSError*)error{
    [SVProgressHUD dismiss];
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
    SIAlertView *alert;
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"很抱歉, 未能成功删除文件"];
        [alert addButtonWithTitle:@"好的" type:SIAlertViewButtonTypeCancel handler:nil];
        [alert show];
    }else{
        alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"Sorry, but there is something wrong while deleting"];
        [alert addButtonWithTitle:@"Cancel" type:SIAlertViewButtonTypeCancel handler:nil];
        [alert show];
    }
}

- (void)viewDidLoad
{
    [self setInitFolders];
    [self setNotification];
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.view.backgroundColor = [UIColor whiteColor];
    self.title = @"Dropbox";
    self.refreshControl = [[UIRefreshControl alloc] init];
    [self.refreshControl addTarget:self
                            action:@selector(refresh)
                  forControlEvents:UIControlEventValueChanged];
    [[self restClient] loadMetadata:@"/"];
    nowPath = @"/";
    [self.paths addObject:nowPath];
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone){
        self.loadFile = [AJProgressPanel showInYourView:self.tableView position:AJPanelPositionBottom];
    }else{
        self.loadFile = [AJProgressPanel showInMyView:self.tableView position:AJPanelPositionBottom];
    }
    
    self.loadFile.progressColor = [UIColor colorWithRed:50.0f/255 green:170.0f/255 blue:193.0f/255 alpha:0.7f];
    self.loadFile.alpha = 0.0;
    [self.loadFile setProgress:0.0 animated:NO];
    
    if (![[HTMLData language] hasPrefix:@"zh"]) {
        [SVProgressHUD showWithStatus:@"Loading..." maskType:SVProgressHUDMaskTypeClear];
    }else{
        [SVProgressHUD showWithStatus:@"读取中..." maskType:SVProgressHUDMaskTypeClear];
    }
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
}

- (void)refreshTable{
    if (![[HTMLData language] hasPrefix:@"zh"]) {
        [SVProgressHUD showWithStatus:@"Reloading..." maskType:SVProgressHUDMaskTypeClear];
    }else{
        [SVProgressHUD showWithStatus:@"重新加载中..." maskType:SVProgressHUDMaskTypeClear];
    }
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
    [[self restClient] loadMetadata:[self.paths lastObject]];
}

- (void)refresh
{
    int64_t delayInSeconds = 0.4;
    dispatch_time_t popTime = dispatch_time(DISPATCH_TIME_NOW, delayInSeconds * NSEC_PER_SEC);
    dispatch_after(popTime, dispatch_get_main_queue(), ^(void){
        [self refreshTable];
        [self.refreshControl endRefreshing];
    });
}

- (void)restClient:(DBRestClient *)client loadedMetadata:(DBMetadata *)metadata {
    [SVProgressHUD dismiss];
    BOOL added = NO;
    
    if (metadata.isDirectory) {
        [self.folders removeAllObjects];
        [self.meta removeAllObjects];
        for (DBMetadata *file in metadata.contents) {
            if (![nowPath isEqualToString:@"/"] && added == NO) {
                if ([[HTMLData language] hasPrefix:@"zh"]) {
                    [self.folders addObject:@"..返回上级目录"];
                    added = YES;
                }else{
                    [self.folders addObject:@"..Back"];
                    added = YES;
                }
                [self.meta addObject:@""];
            
            }
            [self.folders addObject:file.filename];
            [self.meta addObject:[HTMLData changeToProper:file.totalBytes]];
        }
        [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
        [dropboxTable reloadData];
    }else{
        //download file
        
        CGContextRef context = UIGraphicsGetCurrentContext();
        [UIView beginAnimations:@"animationID" context:context];
        [UIView setAnimationDuration:0.5f];
        [UIView setAnimationDelegate:self];
        self.loadFile.alpha = 1.0;
        [UIView commitAnimations];
        [self.loadFile setProgress:0.0 animated:NO];
        
        NSFileManager *manager = [NSFileManager defaultManager];
        BOOL isDir = NO;
        [manager fileExistsAtPath:[[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES) objectAtIndex:0] stringByAppendingFormat:@"/My Dropbox/"] isDirectory:&isDir];
        if (isDir) {
            [[self restClient] loadFile:[self.paths lastObject] intoPath:[[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES) objectAtIndex:0] stringByAppendingFormat:@"/My Dropbox/%@",oldPath]];
        }else{
            [manager createDirectoryAtPath:[[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES) objectAtIndex:0] stringByAppendingFormat:@"/My Dropbox/"] withIntermediateDirectories:NO attributes:nil error:nil];
            [[self restClient] loadFile:[self.paths lastObject] intoPath:[[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES) objectAtIndex:0] stringByAppendingFormat:@"/My Dropbox/%@",oldPath]];
        }
        [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
        
        
        
        if (![[HTMLData language] hasPrefix:@"zh"]) {
            [SVProgressHUD showWithStatus:@"Downloading" maskType:SVProgressHUDMaskTypeClear];
        }else{
            [SVProgressHUD showWithStatus:@"下载中" maskType:SVProgressHUDMaskTypeClear];
        }
    
        
        
    }
    
    
}

- (void)restClient:(DBRestClient*)client loadedFile:(NSString*)localPath
       contentType:(NSString*)contentType metadata:(DBMetadata*)metadata {
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
    
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    [UIView beginAnimations:@"animationID" context:context];
    [UIView setAnimationDuration:0.5f];
    [UIView setAnimationDelegate:self];
    self.loadFile.alpha = 0.0;
    [UIView commitAnimations];
    [self.loadFile setProgress:0.0 animated:NO];
    
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        [SVProgressHUD dismissWithSuccess:@"下载完成" afterDelay:1];
    }else{
        [SVProgressHUD dismissWithSuccess:@"File Downloaded!" afterDelay:1];
    }
    [self.paths removeLastObject];
    [dropboxTable reloadData];
}

- (void)restClient:(DBRestClient*)client loadFileFailedWithError:(NSError*)error {
    [SVProgressHUD dismiss];
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    [UIView beginAnimations:@"animationID" context:context];
    [UIView setAnimationDuration:0.5f];
    [UIView setAnimationDelegate:self];
    self.loadFile.alpha = 0.0;
    [UIView commitAnimations];
    [self.loadFile setProgress:0.0 animated:NO];
    
    SIAlertView *alert;
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"对不起,我们在下载文件时遇到一些麻烦,请稍后重试"];
        [alert addButtonWithTitle:@"取消" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView){
            [self.paths removeLastObject];
            [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
        }];
        [alert addButtonWithTitle:@"重试" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
            [SVProgressHUD dismiss];
            [[self restClient] loadMetadata:[self.paths lastObject]];
            if ([[HTMLData language] hasPrefix:@"zh"]) {
                [SVProgressHUD showWithStatus:@"读取中..." maskType:SVProgressHUDMaskTypeClear];
                
            }else{
                [SVProgressHUD showWithStatus:@"Loading..." maskType:SVProgressHUDMaskTypeClear];
            }
            [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
        }];
        [alert show];
    }else{
        alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"Sorry, but there is some problem while loading. Please try again later."];
        [alert addButtonWithTitle:@"Back" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView){
            [self.paths removeLastObject];
            [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
        }];
        [alert addButtonWithTitle:@"Try again" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
            [SVProgressHUD dismiss];
            [[self restClient] loadMetadata:[self.paths lastObject]];
            if (![[HTMLData language] hasPrefix:@"zh"]) {
                [SVProgressHUD showWithStatus:@"Loading..." maskType:SVProgressHUDMaskTypeClear];
            }else{
                [SVProgressHUD showWithStatus:@"读取中..." maskType:SVProgressHUDMaskTypeClear];
            }
            [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
        }];
        [alert show];
    }

}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    if ([[[[dropboxTable cellForRowAtIndexPath:indexPath] textLabel] text] isEqualToString:@"..返回上级目录"] || [[[[dropboxTable cellForRowAtIndexPath:indexPath] textLabel] text] isEqualToString:@"..Back"]) {
        [self.paths removeLastObject];
        [[self restClient] loadMetadata:[self.paths lastObject]];
        nowPath = [self.paths lastObject];
        if (![[HTMLData language] hasPrefix:@"zh"]) {
            [SVProgressHUD showWithStatus:@"Loading..." maskType:SVProgressHUDMaskTypeClear];
        }else{
            [SVProgressHUD showWithStatus:@"读取中..." maskType:SVProgressHUDMaskTypeClear];
        }
        [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
    }else{
        if ([[self.paths lastObject] hasSuffix:@"/"]) {
            nowPath = [[self.paths lastObject] stringByAppendingFormat:@"%@",[[[dropboxTable cellForRowAtIndexPath:indexPath] textLabel] text]];
        }else{
            nowPath = [[self.paths lastObject] stringByAppendingFormat:@"/%@",[[[dropboxTable cellForRowAtIndexPath:indexPath] textLabel] text]];
        }
        oldPath = [[[dropboxTable cellForRowAtIndexPath:indexPath] textLabel] text];
        [self.paths addObject:nowPath];
        [[self restClient] loadMetadata:nowPath];
        if (![[HTMLData language] hasPrefix:@"zh"]) {
            [SVProgressHUD showWithStatus:@"Loading..." maskType:SVProgressHUDMaskTypeClear];
        }else{
            [SVProgressHUD showWithStatus:@"读取中..." maskType:SVProgressHUDMaskTypeClear];
        }
        [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
    }
}

- (void)restClient:(DBRestClient *)client
loadMetadataFailedWithError:(NSError *)error {
    [SVProgressHUD dismiss];
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    [UIView beginAnimations:@"animationID" context:context];
    [UIView setAnimationDuration:0.5f];
    [UIView setAnimationDelegate:self];
    self.loadFile.alpha = 0.0;
    [UIView commitAnimations];
    [self.loadFile setProgress:0.0 animated:NO];
    
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
    NSLog(@"Error loading metadata: %@", error);
    
    SIAlertView *alert;
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"对不起,我们在读取数据时遇到一些麻烦,请稍后重试"];
        [alert addButtonWithTitle:@"返回" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView){
            [[NSNotificationCenter defaultCenter] postNotificationName:@"getOutFromDropbox" object:nil];
            [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
        }];
        [alert addButtonWithTitle:@"重试" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
            [SVProgressHUD dismiss];
            [[self restClient] loadMetadata:[self.paths lastObject]];
            if (![[HTMLData language] hasPrefix:@"zh"]) {
                [SVProgressHUD showWithStatus:@"Loading..." maskType:SVProgressHUDMaskTypeClear];
            }else{
                [SVProgressHUD showWithStatus:@"读取中..." maskType:SVProgressHUDMaskTypeClear];
            }
            [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
        }];
        [alert show];
    }else{
        alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"Sorry, but there is some problem while loading. Please try again later."];
        [alert addButtonWithTitle:@"Back" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView){
            
            [[NSNotificationCenter defaultCenter] postNotificationName:@"getOutFromDropbox" object:nil];
            [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
        }];
        [alert addButtonWithTitle:@"Try again" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
            [SVProgressHUD dismiss];
            [[self restClient] loadMetadata:[self.paths lastObject]];
            if (![[HTMLData language] hasPrefix:@"zh"]) {
                [SVProgressHUD showWithStatus:@"Loading..." maskType:SVProgressHUDMaskTypeClear];
            }else{
                [SVProgressHUD showWithStatus:@"读取中..." maskType:SVProgressHUDMaskTypeClear];
            }
            [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
        }];
        [alert show];
    }
    
    
}

- (void)restClient:(DBRestClient*)client loadProgress:(CGFloat)progress forFile:(NSString*)destPath{
    [self.loadFile setProgress:progress animated:YES];
}

- (DBRestClient *)restClient {
    if (!restClient) {
        restClient =
        [[DBRestClient alloc] initWithSession:[DBSession sharedSession]];
        restClient.delegate = self;
    }
    return restClient;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
