//
//  AJIndeterminateProgressPanel.h
//  AJIndeterminateProgressPanelDemo
//
//  Created by Alberto Jerez on 21/08/12.
//  Copyright (c) 2012 CodeApps. All rights reserved.
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files
//  (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge,
//  publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
//  subject to the following conditions:
//  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
//  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
//  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>

typedef enum {
    AJPanelPositionTop = 0, //Default
    AJPanelPositionBottom 
} AJPanelPosition;

@interface AJProgressPanel : UIView

//Background gradient start color
@property (nonatomic, strong) UIColor *startGradientColor;

//Background gradient end color
@property (nonatomic, strong) UIColor *endGradientColor;

//Animated stripes color
@property (nonatomic, strong) UIColor *stripesColor;

//Progress bar color
@property (nonatomic, strong) UIColor *progressColor;

//Drop shadow (Default = YES)
@property (nonatomic, assign) BOOL enableShadow;

//Progress (0.0f .. 1.0f)
@property (nonatomic, assign) CGFloat progress;


+ (AJProgressPanel *)showInView:(UIView *)view;
+ (AJProgressPanel *)showInView:(UIView *)view position:(AJPanelPosition)position;
+ (AJProgressPanel *)showInMyView:(UIView *)view position:(AJPanelPosition)position;
+ (AJProgressPanel *)showInYourView:(UIView *)view position:(AJPanelPosition)position;
- (void)hide; //No animated
- (void)hideAnimated:(BOOL)animated;
- (void)setProgress:(CGFloat)progress; //No animated
- (void)setProgress:(CGFloat)progress animated:(BOOL)animated;
@end
