//
//  HTMLCell.m
//  Power HTML
//
//  Created by xrm on 13-5-31.
//  Copyright (c) 2013年 XuRuomeng. All rights reserved.
//

#import "HTMLCell.h"


#define KOCOLOR_FILES_TITLE [UIColor colorWithRed:0.4 green:0.357 blue:0.325 alpha:1] /*#665b53*/
#define KOCOLOR_FILES_TITLE_SHADOW [UIColor colorWithRed:1 green:1 blue:1 alpha:1] /*#ffffff*/
#define KOCOLOR_FILES_COUNTER [UIColor colorWithRed:0.608 green:0.376 blue:0.251 alpha:1] /*#9b6040*/
#define KOCOLOR_FILES_COUNTER_SHADOW [UIColor colorWithRed:1 green:1 blue:1 alpha:0.35] /*#ffffff*/
#define KOCOLOR_FILES_SUBTITLE [UIColor colorWithRed:0.694 green:0.639 blue:0.6 alpha:1] /*#b1a399*/
#define KOCOLOR_FILES_SUBTITLE_SHADOW [UIColor colorWithRed:1 green:1 blue:1 alpha:1] /*#ffffff*/
#define KOCOLOR_FILES_SUBTITLE_VALUE [UIColor colorWithRed:0.694 green:0.639 blue:0.6 alpha:1] /*#b1a399*/
#define KOCOLOR_FILES_SUBTITLE_VALUE_SHADOW [UIColor colorWithRed:1 green:1 blue:1 alpha:1] /*#ffffff*/

#define KOFONT_FILES_TITLE [UIFont fontWithName:@"HelveticaNeue" size:24.0f]
#define KOFONT_FILES_COUNTER [UIFont fontWithName:@"HelveticaNeue-Bold" size:12.0f]
#define KOFONT_FILES_SUBTITLE [UIFont fontWithName:@"HelveticaNeue-Bold" size:13.0f]
#define KOFONT_FILES_SUBTITLE_VALUE [UIFont fontWithName:@"HelveticaNeue" size:13.0f]

@implementation HTMLCell

@synthesize backgroundImageView;
@synthesize isFile;
@synthesize  changedLabel, changedValueLabel, countLabel;
@synthesize indexPath;
@synthesize filePath,folderPath;
@synthesize filename;
@synthesize icon;
@synthesize create;
@synthesize large;
@synthesize mainHTML;
@synthesize isMain;

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        
        
		backgroundImageView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"file-cell-short"]];
		[backgroundImageView setContentMode:UIViewContentModeTopRight];
		
		[self setBackgroundView:backgroundImageView];
		[self setSelectionStyle:UITableViewCellSelectionStyleNone];
		[self.contentView setAutoresizingMask:UIViewAutoresizingFlexibleWidth];
		
        
        [filename setFont:KOFONT_FILES_TITLE];
		[filename setTextColor:KOCOLOR_FILES_TITLE];
		
		[filename.layer setShadowColor:KOCOLOR_FILES_TITLE_SHADOW.CGColor];
		[filename.layer setShadowOffset:CGSizeMake(0, 1)];
		[filename.layer setShadowOpacity:1.0f];
		[filename.layer setShadowRadius:0.0f];
		
		[filename setUserInteractionEnabled:NO];
		[filename setBackgroundColor:[UIColor clearColor]];
		[filename sizeToFit];
		
		[create setFont:KOFONT_FILES_SUBTITLE];
		[create setTextColor:KOCOLOR_FILES_SUBTITLE];
		[create setShadowColor:KOCOLOR_FILES_SUBTITLE_SHADOW];
		[create setShadowOffset:CGSizeMake(0, 1)];
		[create setBackgroundColor:[UIColor clearColor]];
		
		
		[large setFont:KOFONT_FILES_SUBTITLE];
		[large setTextColor:KOCOLOR_FILES_SUBTITLE];
		[large setShadowColor:KOCOLOR_FILES_SUBTITLE_SHADOW];
		[large setShadowOffset:CGSizeMake(0, 1)];
		[large setBackgroundColor:[UIColor clearColor]];

    }
    return self;
}


- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
