//
//  HTMLData.m
//  Power HTML
//
//  Created by xrm on 13-5-31.
//  Copyright (c) 2013年 XuRuomeng. All rights reserved.
//

#import "HTMLData.h"

@implementation HTMLData
+ (BOOL)isLimitPort:(NSInteger)port{
    if (port == 21 || port == 25 || port == 53 || port == 1) {
        return YES;
    }else{
        return NO;
    }
}
+ (NSString *)language{
    NSUserDefaults* defs = [NSUserDefaults standardUserDefaults];
    NSArray* languages = [defs objectForKey:@"AppleLanguages"];
    NSString* preferredLang = [languages objectAtIndex:0];
    return preferredLang;
}
+ (NSArray *)fileList:(NSString *)path{
    NSFileManager *manager = [NSFileManager defaultManager];
    NSError *error = nil;
    return [manager contentsOfDirectoryAtPath:path error:&error];
}
+ (BOOL)isEditableFile:(NSString *)path{
    path = [path lowercaseString];
    while ([path hasSuffix:@"."]) {
        path = [path substringToIndex:[path length] - 1];
    }
    if ([path hasSuffix:@"html"] || [path hasSuffix:@"htm"] || [path hasSuffix:@"js"] || [path hasSuffix:@"css"] || [path hasSuffix:@"php"] || [path hasSuffix:@"jsp"] || [path hasSuffix:@"txt"] || [path hasSuffix:@"text"]  || [path hasSuffix:@".m"] || [path hasSuffix:@".c"] || [path hasSuffix:@".cpp"] || [path hasSuffix:@".h"]) {
        return YES;
    }else{
        return NO;
    }
}
+ (NSInteger)hasDotsInName:(NSString *)path{
    path = [path lowercaseString];
    NSInteger num = 0;
    while ([path hasSuffix:@"."]) {
        path = [path substringToIndex:[path length] - 1];
        num++;
    }
    return num;
}
+ (BOOL)hasHouZhui:(NSString *)name{
    NSString *path = [name lowercaseString];
    if ([path length] == 2) {
        if ([path hasSuffix:@".h"] || [path hasSuffix:@".c"] || [path hasSuffix:@".m"]) {
            return YES;
        }else{
            return NO;
        }
    }else if ([path length] < 3) {
        return NO;
    }else if ([path hasSuffix:@".html"] || [path hasSuffix:@".htm"] || [path hasSuffix:@".3gpp"] || [path hasSuffix:@".3gp"] || [path hasSuffix:@".aac"] || [path hasSuffix:@".aiff"] || [path hasSuffix:@".bmp"] || [path hasSuffix:@".bz2"] || [path hasSuffix:@".c"] || [path hasSuffix:@".zip"] || [path hasSuffix:@".7z"] || [path hasSuffix:@".config"] || [path hasSuffix:@".css"] || [path hasSuffix:@".dmg"] || [path hasSuffix:@".doc"] || [path hasSuffix:@".docx"] || [path hasSuffix:@".flv"] || [path hasSuffix:@".gif"] || [path hasSuffix:@".gz"] || [path hasSuffix:@".h"] || [path hasSuffix:@".ico"] || [path hasSuffix:@".key"] || [path hasSuffix:@".keynote"] || [path hasSuffix:@".numbers"] || [path hasSuffix:@".jpg"] || [path hasSuffix:@".jpeg"] || [path hasSuffix:@".tif"] || [path hasSuffix:@".tiff"] || [path hasSuffix:@".js"] || [path hasSuffix:@".m4v"] || [path hasSuffix:@".mp4"] || [path hasSuffix:@".wav"] || [path hasSuffix:@".mp3"] || [path hasSuffix:@".png"] || [path hasSuffix:@".mov"] || [path hasSuffix:@".ppt"] || [path hasSuffix:@".sql"]||[path hasSuffix:@".sqlite"] || [path hasSuffix:@".pdf"] || [path hasSuffix:@".txt"] || [path hasSuffix:@".text"] || [path hasSuffix:@".pages"] || [path hasSuffix:@"m3u"] || [path hasSuffix:@".flac"] ){
        return YES;
    }else{
        return NO;
    }

}
+ (NSDictionary *)nameAndHouZhui:(NSString *)path{
    NSMutableDictionary *info = [[NSMutableDictionary alloc] init];
    const char *p = [path UTF8String];
    int start,end;
    for (int i = 0; i < strlen(p); i++) {
        if (p[i] == '.') {
            end = i;
        }
        if (p[i] == '/') {
            start = i;
        }
    }
    start +=  1;
    char src[end - start];
    for (int o = start; o < end; o++) {
        src[o-start] = p[o];
    }
    
    NSString *name  = [NSString stringWithCString:src encoding:NSUTF8StringEncoding];
    NSString *houzhui = [path substringFromIndex:end];
    
    
    [info setValue:name forKey:@"name"];
    [info setValue:houzhui forKey:@"houzhui"];
    
    return info;
}
+(NSString *)cutNSString:(NSString *)paramSenderNSString FromLocation:(NSInteger)start To:(NSInteger)end{
    NSString *result = [[NSString alloc] init];
    
    NSMutableString *temp = [[NSMutableString alloc] initWithString:paramSenderNSString];
    
    if (end < start) {
        end=end^start;
        start=start^end;
        end=end^start;
    }
    
    if (start == 0) {
        result = [temp substringToIndex:end];
    }else{
        [temp deleteCharactersInRange:NSMakeRange(0, start - 1)];
        result = [temp substringToIndex:(end - start + 1)];
    }
    return result;
}
+ (BOOL)isMusicFile:(NSString *)path{
    path = [path lowercaseString];
    if ([path hasSuffix:@"mp3"] || [path hasSuffix:@"wav"] || [path hasSuffix:@"flac"]) {
        return YES;
    }else{
        return NO;
    }
}
+ (BOOL)isZipFile:(NSString *)path{
    path = [path lowercaseString];
    if ([path hasSuffix:@".zip"]) {
        return YES;
    }else{
        return NO;
    }
}
+ (BOOL)isVideoFile:(NSString *)path{
    path = [path lowercaseString];
    if ([path hasSuffix:@"mov"] || [path hasSuffix:@"m4v"] || [path hasSuffix:@"mp4"]) {
        return YES;
    }else{
        return NO;
    }
}
+ (BOOL)isImageFile:(NSString *)path{
    NSString *path1 = [[NSString alloc]initWithString:path];
    path = [path uppercaseString];
    if ([path hasSuffix:@"PNG"] || [path hasSuffix:@"JPG"] || [path hasSuffix:@"JPEG"] || [path hasSuffix:@"TIF"] || [path hasSuffix:@"TIFF"] || [path hasSuffix:@"GIF"]) {
        if ([path hasSuffix:@"GIF"]) {
            return [self isGifImage:[NSData dataWithContentsOfFile:path1]];
        }else{
            return YES;
        }
    }else{
        return NO;
    }
}
+ (BOOL)isGifImage:(NSData*)imageData {
	const char* buf = (const char*)[imageData bytes];
	if (buf[0] == 0x47 && buf[1] == 0x49 && buf[2] == 0x46 && buf[3] == 0x38) {
		return YES;
	}
	return NO;
}
+ (BOOL)canOpenThisKindOfFile:(NSString *)path{
    path = [path uppercaseString];
    if ([path hasSuffix:@"HTML"] || [path hasSuffix:@"JS"] || [path hasSuffix:@"CSS"] || [path hasSuffix:@"TXT"] || [path hasSuffix:@"HTM"] || [path hasSuffix:@"PHP"] || [path hasSuffix:@"ASP"] || [path hasSuffix:@"JSP"] || [path hasSuffix:@"TEXT"] || [path hasSuffix:@".M"] || [path hasSuffix:@".C"] || [path hasSuffix:@".CPP"] || [path hasSuffix:@".H"]) {
        return YES;
    }else{
        return NO;
    }
}

+ (BOOL)isDir:(NSString *)path{
    NSFileManager *manager = [NSFileManager defaultManager];
    BOOL isDir = NO;
    [manager fileExistsAtPath:path isDirectory:&isDir];
    return isDir;
}

+ (NSDictionary *)fileInfo:(NSString *)path{
    NSFileManager *fileManager = [NSFileManager defaultManager];
    NSError *error = nil;
    return [fileManager attributesOfItemAtPath:path error:&error];
}

+ (NSString *)changeToProper:(unsigned long long)byte{
    if (byte < 1000) {
        return [NSString stringWithFormat:@"%lldB",byte];
    }else if (byte < 1023 * 1000){
        return [NSString stringWithFormat:@"%.2lfKB",byte/1024.0];
    }else if (byte < 1024 * 1024 * 1000){
        return [NSString stringWithFormat:@"%.2lfMB",(byte/1024.0)/1024];
    }else{
        return [NSString stringWithFormat:@"%.2lfGB",((byte/1024.0)/1024)/1024];
    }
}
+(unsigned long long)fileSizeForDir:(NSString*)path{
    NSFileManager *fileManager = [[NSFileManager alloc] init];
    unsigned long long  size =0;
    NSArray* array = [fileManager contentsOfDirectoryAtPath:path error:nil];
    for(int i = 0; i<[array count]; i++)
    {
        NSString *fullPath = [path stringByAppendingPathComponent:[array objectAtIndex:i]];
        
        BOOL isDir;
        if ( !([fileManager fileExistsAtPath:fullPath isDirectory:&isDir] && isDir) )
        {
            NSDictionary *fileAttributeDic=[fileManager attributesOfItemAtPath:fullPath error:nil];
            size+= fileAttributeDic.fileSize;
        }
        else
        {
            size += [self fileSizeForDir:fullPath];
        }
    }
    return size;
}
@end
