//
//  HTMLPhotoView.m
//  Power HTML
//
//  Created by xrm on 13-6-14.
//  Copyright (c) 2013年 XuRuomeng. All rights reserved.
//

#import "HTMLPhotoView.h"

#define iPhone5 ([UIScreen instancesRespondToSelector:@selector(currentMode)] ? CGSizeEqualToSize(CGSizeMake(640, 1136), [[UIScreen mainScreen] currentMode].size) : NO)

@interface HTMLPhotoView ()

@end

@implementation HTMLPhotoView
@synthesize imageView;
@synthesize image;
@synthesize imageS;
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self.view setBackgroundColor:[UIColor blackColor]];
    
    CGRect frame;
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone){
        if (iPhone5) {
            frame = CGRectMake(0, 0, 320, 568);
        }else{
            frame = CGRectMake(0, 0, 320, 480);
        }
    }else{
        frame = CGRectMake(0, 0, 1024, 768);
    }
    frame.size.height -= 40;
    imageView = [[UIImageView alloc] initWithFrame:frame];
    imageS = [[UIScrollView alloc] initWithFrame:frame];
    [imageS setUserInteractionEnabled:YES];
    [imageS addSubview:imageView];
    [imageView setContentMode:UIViewContentModeScaleAspectFit];
    self.imageView.image = image;
    
    UITapGestureRecognizer *two = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(zoomS)];
    [two setNumberOfTapsRequired:2];
    [two setNumberOfTouchesRequired:1];
    
    
    UITapGestureRecognizer *one = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(exitView)];
    [one setNumberOfTapsRequired:1];
    [one setNumberOfTouchesRequired:1];
    [one requireGestureRecognizerToFail:two];
    [imageS addGestureRecognizer:one];
    
    [imageS setBackgroundColor:[UIColor clearColor]];
    imageS.contentSize = frame.size;
    [imageS setMaximumZoomScale:6];
    [imageS setMinimumZoomScale:1];
    [imageS setTag:888];
    [imageS setDelegate:self];
    [imageS addGestureRecognizer:two];
    [self.view addSubview:imageS];
    
}

- (void)zoomS{
    if (imageS.zoomScale < 2.8) {
        [imageS setZoomScale:6 animated:YES];
    }else{
        [imageS setZoomScale:1 animated:YES];
    }
    
}

- (void)updateImageView{
    self.imageView.image = image;

}

- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView1

{
    if (scrollView1.tag == 888) {
        return imageView;
    }else{
        return nil;
    }
    //返回ScrollView上添加的需要缩放的视图
}

- (void)hidesBar{
    [[UIApplication sharedApplication] setStatusBarHidden:YES withAnimation:UIStatusBarAnimationSlide];
}

- (void)exitView{
    [self dismissViewControllerAnimated:YES completion:^(void){
        self.imageView.image = nil;
        [self.imageS setZoomScale:1];
        //[[UIApplication sharedApplication] setStatusBarHidden:NO];
    }];
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
