//
//  TodoView.m
//  Power HTML
//
//  Created by xrm on 13-7-6.
//  Copyright (c) 2013年 XuRuomeng. All rights reserved.
//

#import "TodoView.h"

#define iPhone5 ([UIScreen instancesRespondToSelector:@selector(currentMode)] ? CGSizeEqualToSize(CGSizeMake(640, 1136), [[UIScreen mainScreen] currentMode].size) : NO)

@interface TodoView ()

@end

@implementation TodoView
@synthesize managedObjectContext;
@synthesize managedObjectModel;
@synthesize persistentStoreCoordinator;
@synthesize filePath;
@synthesize textView_iPad;
@synthesize thisEntity;
@synthesize delegate;
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)keyboardWillShow:(NSNotification *)notification
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        static CGFloat normalKeyboardHeight = 216.0f;
        
        NSDictionary *info = [notification userInfo];
        CGSize kbSize = [[info objectForKey:UIKeyboardFrameEndUserInfoKey] CGRectValue].size;
        
        CGFloat distanceToMove = kbSize.height - normalKeyboardHeight;
        CGRect frame = self.textView.frame;
        frame.size.height -=  distanceToMove;
        if (distanceToMove == 0 && frame.size.height + 216 != self.view.bounds.size.height - 44) {
            frame.size.height += 36;
        }
        self.textView.frame = frame;
    }
    
}

- (void)done{
    if (isNewFileTodo) {
        Entity *entry = (Entity *)[NSEntityDescription insertNewObjectForEntityForName:@"Entity" inManagedObjectContext:self.managedObjectContext];
        [entry setFilePath:filePath];
        if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
            [entry setTodoContent:[self.textView text]];
        }else{
            [entry setTodoContent:[self.textView_iPad text]];
        }
        
        NSError *error;
        
        //托管对象准备好后，调用托管对象上下文的save方法将数据写入数据库
        BOOL isSaveSuccess = [self.managedObjectContext save:&error];
        
        if (!isSaveSuccess) {
            NSLog(@"Error: %@,%@",error,[error userInfo]);
        }else {
        }
        
        [self dismissViewControllerAnimated:YES completion:^(void){
            [self.delegate performSelector:@selector(TodoDidFinished)];
        }];

    }else{
        if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
            [thisEntity setTodoContent:[self.textView text]];
        }else{
            [thisEntity setTodoContent:[self.textView_iPad text]];
        }
        NSError *error;
        
        //托管对象准备好后，调用托管对象上下文的save方法将数据写入数据库
        BOOL isSaveSuccess = [self.managedObjectContext save:&error];
        
        if (!isSaveSuccess) {
            NSLog(@"Error: %@,%@",error,[error userInfo]);
        }else {
        }
        
        [self dismissViewControllerAnimated:YES completion:^(void){
            [self.delegate performSelector:@selector(TodoDidFinished)];
        }];

    }
        
}



- (void)viewDidLoad
{
    [super viewDidLoad];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillShow:) name:UIKeyboardWillShowNotification object:nil];
    UINavigationItem *bar =[[UINavigationItem alloc] initWithTitle:@"To do"];
    NSString *title;
    if ([[HTMLData language]hasPrefix:@"zh"]) {
        title = @"完成";
    }else{
        title = @"Done";
    }
    bar.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:title style:UIBarButtonItemStylePlain target:self action:@selector(done)];
    [self.nav setItems:@[bar] animated:YES];
    
	// Do any additional setup after loading the view.
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone){
        self.textView = [[DALinedTextView alloc] init];
        CGRect frame = CGRectMake(0, 0, self.view.bounds.size.width, 576 - 216);
        if (!iPhone5) {
            frame.size.height = 480 - 216;
        }
        
        frame.origin.y += 44;
        frame.size.height -= 88;
        self.textView.frame = frame;
        [self.view addSubview:self.textView];
        [self.textView becomeFirstResponder];
    }else{
        [self.textView_iPad becomeFirstResponder];
    }
    [self queryFromCoreData];
}

- (void)queryFromCoreData{
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    
    NSEntityDescription *entity = [NSEntityDescription entityForName:@"Entity" inManagedObjectContext:self.managedObjectContext];
    
    [request setEntity:entity];
    NSError *error = nil;
    
    NSMutableArray *mutableFetchResult = [[self.managedObjectContext executeFetchRequest:request error:&error] mutableCopy];
    if (mutableFetchResult == nil) {
        NSLog(@"Error: %@,%@",error,[error userInfo]);
    }
    BOOL found = NO;
    for (Entity *entry in mutableFetchResult) {
        if ([entry.filePath isEqualToString:filePath]) {
            if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone){
                [self.textView setText:entry.todoContent];
            }else{
                [self.textView_iPad setText:entry.todoContent];
            }
            found = YES;
            thisEntity = entry;
            break;
            
        }
    }
    if (found==NO) {
        isNewFileTodo = YES;
    }else{
        isNewFileTodo = NO;
    }
}

- (BOOL)canBecomeFirstResponder{
    return YES;
}

-(NSManagedObjectModel *)managedObjectModel
{
    if (managedObjectModel != nil) {
        return managedObjectModel;
    }
    managedObjectModel = [NSManagedObjectModel mergedModelFromBundles:nil] ;
    return managedObjectModel;
}

-(NSPersistentStoreCoordinator *)persistentStoreCoordinator
{
    if (persistentStoreCoordinator != nil) {
        return persistentStoreCoordinator;
    }
    
    //得到数据库的路径
    NSString *docs = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject];
    docs = [docs substringToIndex:61];
    docs = [docs stringByAppendingString:@"/Library/"];
    //CoreData是建立在SQLite之上的，数据库名称需与Xcdatamodel文件同名
    NSURL *storeUrl = [NSURL fileURLWithPath:[docs stringByAppendingPathComponent:@"Todo.sqlite"]];
    NSError *error = nil;
    persistentStoreCoordinator = [[NSPersistentStoreCoordinator alloc]initWithManagedObjectModel:[self managedObjectModel]];
    
    if (![persistentStoreCoordinator addPersistentStoreWithType:NSSQLiteStoreType configuration:nil URL:storeUrl options:nil error:&error]) {
        NSLog(@"Error: %@,%@",error,[error userInfo]);
    }
    
    return persistentStoreCoordinator;
}

-(NSManagedObjectContext *)managedObjectContext
{
    if (managedObjectContext != nil) {
        return managedObjectContext;
    }
    
    NSPersistentStoreCoordinator *coordinator =[self persistentStoreCoordinator];
    
    if (coordinator != nil) {
        managedObjectContext = [[NSManagedObjectContext alloc]init];
        [managedObjectContext setPersistentStoreCoordinator:coordinator];
    }
    
    return managedObjectContext;
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
@end

