//
//  ViewController_iPad.h
//  Power HTML
//
//  Created by Xu Ruomeng on 13-6-2.
//  Copyright (c) 2013年 XuRuomeng. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#import <MediaPlayer/MediaPlayer.h>
#import <AVFoundation/AVFoundation.h>
#import <arpa/inet.h>
#import <ifaddrs.h>
#import <DropboxSDK/DropboxSDK.h>
#import "HTMLCell.h"
#import "HTMLData.h"
#import "SIAlertView.h"
#import "HTMLSwicth.h"
#import "HTMLPicker_iPad.h"
#import "HTTPServer.h"
#import "DDLog.h"
#import "HTMLFileType.h"
#import "DDTTYLogger.h"
#import "ZipArchive.h"
#import "HTMLEdit.h"
#import "YIPopupTextView.h"
#import "HTMLWiFi.h"
#import "HTMLButton.h"
#import "HMSegmentedControl.h"
#import "HMSegmentedControlContainerView.h"
#import "SLGlowingTextField.h"
#import "ZenKeyboardView.h"
#import "PopoverView.h"
#import "AJProgressPanel.h"
#import "HTMLShowGif.h"
#import "HTMLPhotoView.h"
#import "ZipFile.h"
#import "ZipWriteStream.h"
#import "ZipReadStream.h"
#import "FileInZipInfo.h"
#import "zip.h"
#import "SVProgressHUD.h"
#import "FlatPillButton.h"
#import "DropboxViewController.h"
#import "NaviViewController.h"
#import "ORGMEngine.h"
@class HTTPServer;

@interface AnimatedGifFrame_ipad : NSObject
{
    NSData *data;
	int disposalMethod;
    NSData *header;
	CGRect area;
}
@property (nonatomic, copy) NSData *header;
@property (nonatomic) int disposalMethod;
@property (nonatomic) CGRect area;
@property (nonatomic, copy) NSData *data;
@end

@interface ViewController_iPad : UIViewController<UITableViewDelegate,UIAlertViewDelegate, UITableViewDataSource,UIScrollViewDelegate,UINavigationControllerDelegate,UIImagePickerControllerDelegate,AVAudioPlayerDelegate,DBRestClientDelegate,PopoverViewDelegate, YIPopupTextViewDelegate,PickerDelegate_iPad,ZenKeyboardViewDelegate,HTMLCodeSendDelegate,ORGMEngineDelegate>{
    HTTPServer *httpServer;
    PopoverView *pv;
    PopoverView *pv1;
    HTMLCodeSend *myCode;
    MPMoviePlayerController *moviePlayer;
    AVAudioPlayer *audioPlayer;
    UIView *musicView;
    UIButton *play;
    UIButton *rewind;
    UIButton *fastforward;
    NSTimer *updateDur;
    CGPoint point;
    PopoverView *videoPop;
    PopoverView *musicPop;
    PopoverView *rename;
    HTMLCell *selectCell;
    NSData *GIF_pointer;
	NSMutableData *GIF_buffer;
	NSMutableData *GIF_screen;
	NSMutableData *GIF_global;
	NSMutableArray *GIF_frames;
	
	int GIF_sorted;
	int GIF_colorS;
	int GIF_colorC;
	int GIF_colorF;
	int animatedGifDelay;
	
	int dataPointer;
    
    NaviViewController *nav;
    
    HTMLPhotoView *photoDetail;
    NSString *photoPath;
    NSString *_fileNameInZip;
    NSString *itemToMove;
    NSString *itemToCopy;
    BOOL isCopy;
    BOOL hasItemToDo;
    ZipArchive *zip;
    NSInteger sourceFolderPathLength;
    BOOL isFLAC;
@private
	zipFile _zipFile;
}
@property (strong, nonatomic) NSDictionary *metadata;
@property (strong, nonatomic) ORGMEngine* FLACplayer;
@property (nonatomic) NSUInteger theRow;
@property (nonatomic,strong) AJProgressPanel *uploadFile;
@property (nonatomic,strong) AJProgressPanel *panel;
@property (nonatomic, strong) UIScrollView *imageS;
@property (nonatomic, strong) UIImageView *image1;
@property (nonatomic, strong) NSMutableDictionary *codeinfo;
@property (nonatomic, strong) UIPopoverController *popoverController;
@property (nonatomic, strong) UIButton *addFile;
@property (strong, nonatomic) IBOutlet UILabel *screenLabel;
@property (strong, nonatomic) IBOutlet UILabel *httpPortLabel;
@property (strong, nonatomic) IBOutlet UILabel *httpPortViewLabel;
@property (nonatomic, strong) SLGlowingTextField *needName;
@property (nonatomic, strong) ZenKeyboardView *keyboardView;
@property (nonatomic, strong) NSString *contentOfHTML;
@property (nonatomic, strong) HMSegmentedControl *fileType;
@property (strong, nonatomic) IBOutlet SLGlowingTextField *serverPort;
@property (nonatomic, strong) NSTimer *firstTime;
@property (nonatomic) NSInteger pic;
@property (nonatomic, strong) UIImageView *tip;
@property (nonatomic, strong) UIDevice *device;
@property (nonatomic, strong) NSTimer *timer;
@property (nonatomic, strong) IBOutlet UIScrollView *scrollView;
@property (nonatomic, strong) IBOutlet HTMLSwicth *keepLit;
@property (nonatomic, strong) IBOutlet HTMLSwicth *keepLitWhenServer;
@property (nonatomic, strong) IBOutlet HTMLSwicth *keepLitWhenPower;
@property (nonatomic, strong) IBOutlet UILabel *keepLitLabel;
@property (nonatomic, strong) IBOutlet UILabel *keepLitWhenServerLabel;
@property (nonatomic, strong) IBOutlet UILabel *keepLitWhenPowerLabel;
@property (nonatomic, strong) IBOutlet UIImageView *bg;
@property (nonatomic) BOOL isRootView,isDropboxView;
@property (strong, nonatomic) NSString *nowPath, *oldPath, *docPath;
@property (strong, nonatomic) UITableView *iPhoneTableView;
@property (strong) UIView *shadowViewBottom;
@property (strong) UIView *shadowViewTop;
@property (strong, nonatomic) UIImageView *backBtn;
@property (strong, nonatomic) UIImageView *toolbar;
@property (nonatomic, strong) NSArray *fileList;
@property (nonatomic, strong) UIButton *newbtn;
@property (nonatomic, strong) UIButton *newbtn1;
@property (nonatomic, strong) HTMLWiFi *enableWIFI;
@property (nonatomic, strong) UIButton *settings;
@property (nonatomic, strong) NSMutableArray *paths;
@property (nonatomic, strong) FlatPillButton *dropbox;
@property (nonatomic, strong) FlatPillButton *dropboxFolder;
@end
