//
//  ViewController_iPad.m
//  Power HTML
//
//  Created by Xu Ruomeng on 13-6-2.
//  Copyright (c) 2013年 XuRuomeng. All rights reserved.
//

#import "ViewController_iPad.h"

#define IOS_VERSION [[[UIDevice currentDevice] systemVersion] floatValue]

@implementation AnimatedGifFrame_ipad

@synthesize disposalMethod, area, data,header;

@end

@interface ViewController_iPad (){
    HMSegmentedControlContainerView *containerView;
}
@property (nonatomic, readonly) DBRestClient *restClient;
@end

@implementation ViewController_iPad

@synthesize iPhoneTableView;
@synthesize shadowViewBottom;
@synthesize shadowViewTop;
@synthesize fileList;
@synthesize isRootView;
@synthesize nowPath;
@synthesize metadata;
@synthesize theRow;
@synthesize oldPath;
@synthesize backBtn;
@synthesize toolbar;
@synthesize docPath;
@synthesize paths;
@synthesize newbtn;
@synthesize newbtn1;
@synthesize enableWIFI;
@synthesize settings;
@synthesize keepLit;
@synthesize keepLitWhenServer;
@synthesize keepLitWhenPower;
@synthesize keepLitLabel;
@synthesize keepLitWhenServerLabel;
@synthesize keepLitWhenPowerLabel;
@synthesize bg;
@synthesize scrollView;
@synthesize timer;
@synthesize device;
@synthesize tip;
@synthesize pic;
@synthesize firstTime;
@synthesize fileType;
@synthesize serverPort;
@synthesize httpPortLabel;
@synthesize httpPortViewLabel;
@synthesize screenLabel;
@synthesize contentOfHTML;
@synthesize needName;
@synthesize addFile;
@synthesize popoverController;
@synthesize codeinfo;
@synthesize image1;
@synthesize imageS;
@synthesize restClient;
@synthesize dropbox;
@synthesize dropboxFolder;
@synthesize isDropboxView;
@synthesize uploadFile;

- (void)configSrcollView{
    scrollView.contentSize = CGSizeMake(1024, 770);
    scrollView.showsVerticalScrollIndicator = NO;
    scrollView.showsHorizontalScrollIndicator = NO;
    scrollView.delegate = self;
    scrollView.bounces = YES;
    scrollView.userInteractionEnabled = YES;
    scrollView.bouncesZoom = YES;
    scrollView.delaysContentTouches = NO;
    scrollView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleRightMargin;
}

- (void)didNumericKeyPressed:(UIButton *)button {
    if ([button.titleLabel.text isEqualToString:@"完成"] || [button.titleLabel.text isEqualToString:@"Done"]) {
        [serverPort resignFirstResponder];
        return;
    }
    if ([[serverPort text] length] == 5) {
        return;
    }
    serverPort.text = [NSString stringWithFormat:@"%@%@", serverPort.text, button.titleLabel.text];
    
}

- (void)didBackspaceKeyPressed {
    NSInteger length = serverPort.text.length;
    if (length == 0) {
        serverPort.text = @"";
        
        return;
    }
    
    NSString *substring = [serverPort.text substringWithRange:NSMakeRange(0, length - 1)];
    serverPort.text = substring;
}


- (BOOL)textFieldShouldEndEditing:(UITextField *)textField{
    if ([[textField text]length] == 0) {
        NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
        [d setValue:@"80" forKey:@"Port"];
        return YES;
    }
    if ([[textField text]integerValue] > 65536 || [[textField text] integerValue] < 1) {
        SIAlertView *alert;
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"端口号最大不超过65536,请输入一个不为0且不大于65536的数"];
            [alert addButtonWithTitle:@"好的" type:SIAlertViewButtonTypeDestructive handler:nil];
        }else{
            alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"Port should be less or equal 65536, and 0 is not accept\nPlease enter again."];
            [alert addButtonWithTitle:@"OK" type:SIAlertViewButtonTypeDestructive handler:nil];
        }
        [alert show];
        return NO;
    }else if ([HTMLData isLimitPort:[[serverPort text] integerValue]]){
        SIAlertView *alert;
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"不能使用受限制的网络端口,请重新输入"];
            [alert addButtonWithTitle:@"好的" type:SIAlertViewButtonTypeDestructive handler:nil];
        }else{
            alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"It is not allow to use the restricted network port\nPlease enter again."];
            [alert addButtonWithTitle:@"OK" type:SIAlertViewButtonTypeDestructive handler:nil];
        }
        [alert show];
        return NO;
    }else{
        NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
        [d setValue:[serverPort text] forKey:@"Port"];
        return YES;
    }
    
}


- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex{
    if (IOS_VERSION < 6.3) {
        if (alertView.tag == 999) {
            if (buttonIndex == 1) {
                NSString *text = [needName text];
                BOOL canrename = YES;
                for (NSString *name in [self fileList]) {
                    if ([name isEqualToString:text]) {
                        canrename = NO;
                        break;
                    }
                }
                NSString *houzhui = [selectCell.filename.text pathExtension];
                for (NSString *name in [self fileList]) {
                    if ([name isEqualToString:[text stringByAppendingFormat:@".%@",houzhui]]) {
                        canrename = NO;
                        break;
                    }
                }
                //NSInteger num = [HTMLData hasDotsInName:selectCell.filePath];
                if (canrename) {
                    if ([HTMLData hasHouZhui:selectCell.filePath]) {
                        NSString *houzui = [selectCell.filename.text pathExtension];
                        
                        NSFileManager *manager = [NSFileManager defaultManager];
                        [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,houzui] error:nil];
                    }else{
                        
                        
                        NSFileManager *manager = [NSFileManager defaultManager];
                        [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text] error:nil];
                    }
                    
                    [self updateTable];
                    
                }else{
                    if ([[HTMLData language]hasPrefix:@"zh"]) {
                        SIAlertView *alert = [[SIAlertView alloc]initWithTitle:@"提示" andMessage:@"与现有文件的文件名重复"];
                        [alert addButtonWithTitle:@"取消" type:SIAlertViewButtonTypeCancel handler:nil];
                        [alert addButtonWithTitle:@"覆盖现有文件" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView1){
                            NSFileManager *manager = [NSFileManager defaultManager];
                            if ([manager fileExistsAtPath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text]]) {
                                [manager removeItemAtPath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text] error:nil];
                            }else{
                                [manager removeItemAtPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,[selectCell.filename.text pathExtension]] error:nil];
                            }
                            
                            
                            //NSInteger s = [[selectCell.filename.text pathExtension]length];
                            
                            //NSString *filesname = [selectCell.filename.text substringToIndex:s];
                            NSString *houzui = [selectCell.filename.text pathExtension];
                            if ([HTMLData hasHouZhui:selectCell.filePath]) {
                                [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,houzui] error:nil];
                            }else{
                                [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,[houzui substringToIndex:[houzui length] - 1]] error:nil];
                            }
                            
                            [self updateTable];
                            
                        }];
                        [alert addButtonWithTitle:@"保留两个文件" type:SIAlertViewButtonTypeDestructive   handler:^(SIAlertView *alertView1){
                            int i = 1;
                            while (1) {
                                NSString *newname = [text stringByAppendingFormat:@"(%d)",i];
                                NSString *newname1 = [text stringByAppendingFormat:@"(%d).%@",i,houzhui];
                                if ([[self fileList]containsObject:newname] || [[self fileList]containsObject:newname1]) {
                                    i++;
                                }else{
                                    
                                    NSString *houzui = [selectCell.filename.text pathExtension];
                                    
                                    NSFileManager *manager = [NSFileManager defaultManager];
                                    [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],newname,houzui] error:nil];
                                    [self updateTable];
                                    break;
                                }
                                
                            }
                        }];
                        [alert show];
                        
                    }else{
                        SIAlertView *alert = [[SIAlertView alloc]initWithTitle:@"Warning" andMessage:@"Duplicate filename"];
                        [alert addButtonWithTitle:@"Cancel" type:SIAlertViewButtonTypeCancel handler:nil];
                        [alert addButtonWithTitle:@"Overwrite" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView1){
                            NSFileManager *manager = [NSFileManager defaultManager];
                            if ([manager fileExistsAtPath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text]]) {
                                [manager removeItemAtPath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text] error:nil];
                            }else{
                                [manager removeItemAtPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,[selectCell.filename.text pathExtension]] error:nil];
                            }
                            
                            
                            //NSInteger s = [[selectCell.filename.text pathExtension]length];
                            
                            //NSString *filesname = [selectCell.filename.text substringToIndex:s];
                            NSString *houzui = [selectCell.filename.text pathExtension];
                            if ([HTMLData hasHouZhui:selectCell.filePath]) {
                                [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,houzui] error:nil];
                            }else{
                                [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,[houzui substringToIndex:[houzui length] - 1]] error:nil];
                            }
                            
                            [self updateTable];
                            
                        }];
                        [alert addButtonWithTitle:@"Keep Both" type:SIAlertViewButtonTypeDestructive   handler:^(SIAlertView *alertView1){
                            int i = 1;
                            while (1) {
                                NSString *newname = [text stringByAppendingFormat:@"(%d)",i];
                                NSString *newname1 = [text stringByAppendingFormat:@"(%d).%@",i,houzhui];
                                if ([[self fileList]containsObject:newname] || [[self fileList]containsObject:newname1]) {
                                    i++;
                                }else{
                                    
                                    NSString *houzui = [selectCell.filename.text pathExtension];
                                    
                                    NSFileManager *manager = [NSFileManager defaultManager];
                                    [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],newname,houzui] error:nil];
                                    [self updateTable];
                                    break;
                                }
                                
                            }
                        }];
                        [alert show];
                        
                    }
                }
                return;
            }
            NSString *text = [needName text];
            [contentOfHTML writeToFile:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text] atomically:YES encoding:NSUTF8StringEncoding error:nil];
            contentOfHTML = nil;
        }
        
    }else{
        if (alertView.tag == 999) {
            if (buttonIndex == 1) {
                NSString *text = [[alertView textFieldAtIndex:0] text];
                BOOL canrename = YES;
                for (NSString *name in [self fileList]) {
                    if ([name isEqualToString:text]) {
                        canrename = NO;
                        break;
                    }
                }
                NSString *houzhui = [selectCell.filename.text pathExtension];
                for (NSString *name in [self fileList]) {
                    if ([name isEqualToString:[text stringByAppendingFormat:@".%@",houzhui]]) {
                        canrename = NO;
                        break;
                    }
                }
                //NSInteger num = [HTMLData hasDotsInName:selectCell.filePath];
                if (canrename) {
                    if ([HTMLData hasHouZhui:selectCell.filePath]) {
                        NSString *houzui = [selectCell.filename.text pathExtension];
                        
                        NSFileManager *manager = [NSFileManager defaultManager];
                        [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,houzui] error:nil];
                    }else{
                        
                        
                        NSFileManager *manager = [NSFileManager defaultManager];
                        [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text] error:nil];
                    }
                    
                    [self updateTable];
                    
                }else{
                    if ([[HTMLData language]hasPrefix:@"zh"]) {
                        SIAlertView *alert = [[SIAlertView alloc]initWithTitle:@"提示" andMessage:@"与现有文件的文件名重复"];
                        [alert addButtonWithTitle:@"取消" type:SIAlertViewButtonTypeCancel handler:nil];
                        [alert addButtonWithTitle:@"覆盖现有文件" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView1){
                            NSFileManager *manager = [NSFileManager defaultManager];
                            if ([manager fileExistsAtPath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text]]) {
                                [manager removeItemAtPath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text] error:nil];
                            }else{
                                [manager removeItemAtPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,[selectCell.filename.text pathExtension]] error:nil];
                            }
                            
                            
                            //NSInteger s = [[selectCell.filename.text pathExtension]length];
                            
                            //NSString *filesname = [selectCell.filename.text substringToIndex:s];
                            NSString *houzui = [selectCell.filename.text pathExtension];
                            if ([HTMLData hasHouZhui:selectCell.filePath]) {
                                [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,houzui] error:nil];
                            }else{
                                [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,[houzui substringToIndex:[houzui length] - 1]] error:nil];
                            }
                            
                            [self updateTable];
                            
                        }];
                        [alert addButtonWithTitle:@"保留两个文件" type:SIAlertViewButtonTypeDestructive   handler:^(SIAlertView *alertView1){
                            int i = 1;
                            while (1) {
                                NSString *newname = [text stringByAppendingFormat:@"(%d)",i];
                                NSString *newname1 = [text stringByAppendingFormat:@"(%d).%@",i,houzhui];
                                if ([[self fileList]containsObject:newname] || [[self fileList]containsObject:newname1]) {
                                    i++;
                                }else{
                                    
                                    NSString *houzui = [selectCell.filename.text pathExtension];
                                    
                                    NSFileManager *manager = [NSFileManager defaultManager];
                                    [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],newname,houzui] error:nil];
                                    [self updateTable];
                                    break;
                                }
                                
                            }
                        }];
                        [alert show];
                        
                    }else{
                        SIAlertView *alert = [[SIAlertView alloc]initWithTitle:@"Warning" andMessage:@"Duplicate filename"];
                        [alert addButtonWithTitle:@"Cancel" type:SIAlertViewButtonTypeCancel handler:nil];
                        [alert addButtonWithTitle:@"Overwrite" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView1){
                            NSFileManager *manager = [NSFileManager defaultManager];
                            if ([manager fileExistsAtPath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text]]) {
                                [manager removeItemAtPath:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text] error:nil];
                            }else{
                                [manager removeItemAtPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,[selectCell.filename.text pathExtension]] error:nil];
                            }
                            
                            
                            //NSInteger s = [[selectCell.filename.text pathExtension]length];
                            
                            //NSString *filesname = [selectCell.filename.text substringToIndex:s];
                            NSString *houzui = [selectCell.filename.text pathExtension];
                            if ([HTMLData hasHouZhui:selectCell.filePath]) {
                                [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,houzui] error:nil];
                            }else{
                                [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],text,[houzui substringToIndex:[houzui length] - 1]] error:nil];
                            }
                            
                            [self updateTable];
                            
                        }];
                        [alert addButtonWithTitle:@"Keep Both" type:SIAlertViewButtonTypeDestructive   handler:^(SIAlertView *alertView1){
                            int i = 1;
                            while (1) {
                                NSString *newname = [text stringByAppendingFormat:@"(%d)",i];
                                NSString *newname1 = [text stringByAppendingFormat:@"(%d).%@",i,houzhui];
                                if ([[self fileList]containsObject:newname] || [[self fileList]containsObject:newname1]) {
                                    i++;
                                }else{
                                    
                                    NSString *houzui = [selectCell.filename.text pathExtension];
                                    
                                    NSFileManager *manager = [NSFileManager defaultManager];
                                    [manager moveItemAtPath:selectCell.filePath toPath:[NSString stringWithFormat:@"%@/%@.%@",[self.paths lastObject],newname,houzui] error:nil];
                                    [self updateTable];
                                    break;
                                }
                                
                            }
                        }];
                        [alert show];
                        
                    }
                }
                
            }
            NSString *text = [[alertView textFieldAtIndex:0] text];
            [contentOfHTML writeToFile:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],text] atomically:YES encoding:NSUTF8StringEncoding error:nil];
            contentOfHTML = nil;
        }
        
    }
    self.fileList = [HTMLData fileList:[self.paths lastObject]];
    [iPhoneTableView reloadData];
}

- (void)setUI{
    _keyboardView = [[ZenKeyboardView alloc] initWithFrame:CGRectMake(0, 0, 1024, 360)];
    _keyboardView.delegate = self;
    
    [serverPort setFont:[UIFont fontWithName:@"HelveticaNeue-Light" size:17.0f]];
    serverPort.textAlignment = NSTextAlignmentRight;
    serverPort.adjustsFontSizeToFitWidth = YES;
    serverPort.inputView = _keyboardView;
    
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        serverPort.placeholder = @"默认为80端口";
        screenLabel.text = @"屏幕";
        httpPortViewLabel.text = @"HTTP服务端口";
        httpPortLabel.text = @"HTTP端口";
    }else{
        serverPort.placeholder = @"Default as 80";
        screenLabel.text = @"Screen";
        httpPortViewLabel.text = @"HTTP Server Port";
        httpPortLabel.text = @"HTTP Port";
    }
    
    NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
    if ([d valueForKey:@"Port"] == NULL) {
        serverPort.text = @"80";
    }else{
        serverPort.text = [d valueForKey:@"Port"];
    }

}

- (void)lit:(HTMLSwicth *)sender{
    if (sender.tag == 1) {
        
        NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
        [d setBool:keepLitWhenServer.on forKey:@"KeepLitWhenServer"];
        if (sender.on) {
            [timer setFireDate:[NSDate distantFuture]];
            timer = [NSTimer scheduledTimerWithTimeInterval:30 target:self selector:@selector(littime) userInfo:nil repeats:YES];
            [timer setFireDate:[NSDate distantPast]];
            [timer fire];
        }
        
    }else if (sender.tag == 2){
        NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
        [d setBool:keepLitWhenPower.on forKey:@"KeepLitWhenPower"];
        if (sender.on) {
            [timer setFireDate:[NSDate distantFuture]];
            timer = [NSTimer scheduledTimerWithTimeInterval:30 target:self selector:@selector(littime) userInfo:nil repeats:YES];
            [timer setFireDate:[NSDate distantPast]];
            [timer fire];
        }
    }else{
        NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
        [d setBool:keepLit.on forKey:@"KeepLit"];
        if (sender.on) {
            if (keepLitWhenServer.on || keepLitWhenPower.on) {
                [timer setFireDate:[NSDate distantFuture]];
                timer = [NSTimer scheduledTimerWithTimeInterval:30 target:self selector:@selector(littime) userInfo:nil repeats:YES];
                [timer setFireDate:[NSDate distantPast]];
                [timer fire];
            }else{
                [UIApplication sharedApplication].idleTimerDisabled=YES;
            }
        }
    }
    keepLitWhenServer.userInteractionEnabled = keepLitWhenPower.userInteractionEnabled = keepLit.on;
    [UIView animateWithDuration:0.3f
                          delay:0.0f
                        options:UIViewAnimationOptionCurveEaseOut
                     animations:^{
                         keepLitWhenPower.alpha = keepLitWhenServer.alpha = (keepLit.on ? 1.0f : 0.3f);
                     } completion:nil];
}

- (void)littime{
    if (keepLitWhenServer.on == YES) {
        if (enableWIFI.wifiOn == YES) {
            [UIApplication sharedApplication].idleTimerDisabled=YES;
        }else{
            [UIApplication sharedApplication].idleTimerDisabled=NO;
        }
    }else{
        if (device.batteryState == UIDeviceBatteryStateCharging){
            [UIApplication sharedApplication].idleTimerDisabled=YES;
        }else{
            [UIApplication sharedApplication].idleTimerDisabled=NO;
        }
    }
}

- (void)startServer
{
    // Start the server (and check for problems)
	
	NSError *error;
	if([httpServer start:&error])
	{
	}
	else
	{

	}
}

- (void)picked:(NSInteger)tag{
    NSString *path = [docPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:tag]];
    [self startServerAtPath:path];
    [enableWIFI setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI_e" ofType:@"png"]] forState:UIControlStateNormal];
    [enableWIFI setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI_e" ofType:@"png"]] forState:UIControlStateHighlighted];
    enableWIFI.wifiOn = YES;
    SIAlertView *alert;
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"在浏览器中打开\nhttp://%@\n即可浏览网页",[self WiFiIPAddress]]];
        [alert addButtonWithTitle:@"好的" type:SIAlertViewButtonTypeCancel handler:nil];
    }else{
        alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"Done! Open this link\nhttp://%@\nin browser.",[self WiFiIPAddress]]];
        [alert addButtonWithTitle:@"OK" type:SIAlertViewButtonTypeCancel handler:nil];
    }

    [alert show];
}

- (void)prepareFile{
    docPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES) objectAtIndex:0];
    
    fileList = [[NSArray alloc]init];
    fileList = [HTMLData fileList:docPath];
}

- (void)cnew{
    YIPopupTextView* popupTextView;
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        popupTextView = [[YIPopupTextView alloc] initWithPlaceHolder:@"新的工程名字..."
                                                            maxCount:1000
                                                         buttonStyle:YIPopupTextViewButtonStyleRightCancelAndDone
                                                     tintsDoneButton:YES];
    }else{
        popupTextView = [[YIPopupTextView alloc] initWithPlaceHolder:@"New Project Name..."
                                                            maxCount:1000
                                                         buttonStyle:YIPopupTextViewButtonStyleRightCancelAndDone
                                                     tintsDoneButton:YES];
    }
    
    popupTextView.delegate = self;
    popupTextView.tag = 1;
    popupTextView.caretShiftGestureEnabled = YES;
    [popupTextView showInView:self.view];
}

- (void)cnew1{
    YIPopupTextView* popupTextView;
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        popupTextView= [[YIPopupTextView alloc] initWithPlaceHolder:@"新的文件名称或网址..."
                                                           maxCount:210
                                                        buttonStyle:YIPopupTextViewButtonStyleRightCancelAndDone
                                                    tintsDoneButton:YES];
    }else{
        popupTextView= [[YIPopupTextView alloc] initWithPlaceHolder:@"New File Name Or URL..."
                                                           maxCount:210
                                                        buttonStyle:YIPopupTextViewButtonStyleRightCancelAndDone
                                                    tintsDoneButton:YES];
    }

    popupTextView.delegate = self;
    popupTextView.tag = 2;
    popupTextView.caretShiftGestureEnabled = YES;

    [popupTextView showInView:self.view];
    [NSTimer scheduledTimerWithTimeInterval:0.25 target:self selector:@selector(showSeg) userInfo:nil repeats:NO];
    
}



- (NSString *)fileNameFromWeb:(NSString *)webPath{
    const char *name = [webPath UTF8String];
    int i;
    for (i = strlen(name); i >= 0; i--) {
        if (name[i] == '/') {
            break;
        }
    }
    return [self cutNSString:webPath FromLocation:i To:strlen(name)];
}

-(NSString *)cutNSString:(NSString *)paramSenderNSString FromLocation:(NSInteger)start To:(NSInteger)end{
    NSString *result = [[NSString alloc] init];
    
    NSMutableString *temp = [[NSMutableString alloc] initWithString:paramSenderNSString];
    
    if (end < start) {
        end=end^start;
        start=start^end;
        end=end^start;
    }
    
    if (start == 0) {
        result = [temp substringToIndex:end];
    }else{
        [temp deleteCharactersInRange:NSMakeRange(0, start - 1)];
        result = [temp substringToIndex:(end - start + 1)];
    }
    return result;
}

- (NSString *) replaceHTMLCodeWithReadableString:(NSString *)HTMLContent{
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&Alpha" withString:@"α"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&Beta" withString:@"β"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&Delta" withString:@"Δ"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&Theta" withString:@"Θ"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&Xi" withString:@"Ξ"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&Pi" withString:@"π"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&Sigma" withString:@"Σ"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&Omega" withString:@"Ω"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&delta" withString:@"δ"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&zeta" withString:@"ζ"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&reg" withString:@"®"];
    HTMLContent = [HTMLContent stringByReplacingOccurrencesOfString:@"&nbsp;" withString:@" "];
    return HTMLContent;
}


- (void)showSeg{
    [containerView setHidden:NO];
    [containerView setUserInteractionEnabled:YES];
    [self.view bringSubviewToFront:containerView];
}


- (void)popupTextView:(YIPopupTextView *)textView willDismissWithText:(NSString *)text cancelled:(BOOL)cancelled
{
    [self.view sendSubviewToBack:containerView];
    [containerView setHidden:YES];
    [containerView setUserInteractionEnabled:NO];
    
    
    if (cancelled == 0 && [text length] > 0) {
        if (textView.tag == 1) {
            NSString *path = [NSString stringWithFormat:@"%@/%@",docPath,text];
            NSFileManager *manager = [NSFileManager defaultManager];
            NSError *error = nil;
            [manager createDirectoryAtPath:path withIntermediateDirectories:NO attributes:nil error:&error];
            self.fileList = [manager contentsOfDirectoryAtPath:docPath error:&error];
            [iPhoneTableView reloadData];
        }
        if (textView.tag == 2) {
            if ([fileType selectedSegmentIndex] == 1) {
                NSString *path = [NSString stringWithFormat:@"%@/%@.html",[self.paths lastObject],text];
                NSFileManager *manager = [NSFileManager defaultManager];
                NSError *error = nil;
                [manager createFileAtPath:path contents:nil attributes:nil];
                self.fileList = [manager contentsOfDirectoryAtPath:[self.paths lastObject] error:&error];
                [iPhoneTableView reloadData];
                NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
                text = [text stringByAppendingFormat:@".html"];
                [d setValue:text forKey:[self.paths lastObject]];//main HTML
            }else if ([fileType selectedSegmentIndex] == 2){
                NSString *path = [NSString stringWithFormat:@"%@/%@.css",[self.paths lastObject],text];
                NSFileManager *manager = [NSFileManager defaultManager];
                NSError *error = nil;
                [manager createFileAtPath:path contents:nil attributes:nil];
                self.fileList = [manager contentsOfDirectoryAtPath:[self.paths lastObject] error:&error];
                [iPhoneTableView reloadData];
            }else if ([fileType selectedSegmentIndex] == 3){
                NSString *path = [NSString stringWithFormat:@"%@/%@.js",[self.paths lastObject],text];
                NSFileManager *manager = [NSFileManager defaultManager];
                NSError *error = nil;
                [manager createFileAtPath:path contents:nil attributes:nil];
                self.fileList = [manager contentsOfDirectoryAtPath:[self.paths lastObject] error:&error];
                [iPhoneTableView reloadData];
            }else if ([fileType selectedSegmentIndex] == 4){
                NSString *path = [NSString stringWithFormat:@"%@/%@.htm",[self.paths lastObject],text];
                NSFileManager *manager = [NSFileManager defaultManager];
                NSError *error = nil;
                [manager createFileAtPath:path contents:nil attributes:nil];
                self.fileList = [manager contentsOfDirectoryAtPath:[self.paths lastObject] error:&error];
                [iPhoneTableView reloadData];
                NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
                text = [text stringByAppendingFormat:@".htm"];
                [d setValue:text forKey:[self.paths lastObject]];//main HTM
            }else if ([fileType selectedSegmentIndex] == 0){
                if ([[textView text]hasPrefix:@"http://"]) {
                    NSStringEncoding enc = CFStringConvertEncodingToNSStringEncoding(kCFStringEncodingGB_18030_2000);
                    NSString *html = [[NSString alloc] initWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:[[textView text] stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]]] encoding:enc];
                    if (html == NULL) {
                        html = [[NSString alloc] initWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:[[textView text] stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]]] encoding:NSUTF8StringEncoding];
                        
                    }
                    
                    
                    if ([[textView text]hasSuffix:@"html"] || [[textView text]hasSuffix:@"htm"]) {
                        NSString *result = [[NSString alloc] init];
                        //NSMutableString *tmp1 = [[NSMutableString alloc] initWithString:content];
                        
                        NSString *start = @"<title>";
                        NSString *end = @"</title>";
                        NSRange rangeStart,rangeEnd;
                        rangeStart = [html rangeOfString:start];
                        rangeEnd = [html rangeOfString:end];
                        
                        result = [self cutNSString:html FromLocation:(rangeStart.location + rangeStart.length + 1) To:rangeEnd.location];
                        result = [self replaceHTMLCodeWithReadableString:result];
                        
                        [html writeToFile:[NSString stringWithFormat:@"%@/%@.html",[self.paths lastObject],result] atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    }else{
                        needName = [[SLGlowingTextField alloc] initWithFrame:CGRectMake(20, 80, 242, 30)];
                        if ([[HTMLData language]hasPrefix:@"zh"]) {
                            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"请输入文件名\n\n\n" delegate:self cancelButtonTitle:@"取消" otherButtonTitles:@"好的", nil];
                            if (IOS_VERSION > 6.2) {
                                [alert setAlertViewStyle:UIAlertViewStylePlainTextInput];
                            }
                            [alert addSubview:needName];
                            [alert setDelegate:self];
                            [alert show];
                        }else{
                            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Warning" message:@"Please enter filename\n\n\n" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil];
                            if (IOS_VERSION > 6.2) {
                                [alert setAlertViewStyle:UIAlertViewStylePlainTextInput];
                            }
                            [alert addSubview:needName];
                            [alert setDelegate:self];
                            [alert show];
                        }
                        
                        
                        contentOfHTML = [[NSString alloc] initWithFormat:@"%@",html];
                        
                        //html
                        
                    }
                    
                }else{
                    //No http://
                    NSString *url = [@"http://" stringByAppendingString:[textView text]];
                    NSStringEncoding enc = CFStringConvertEncodingToNSStringEncoding(kCFStringEncodingGB_18030_2000);
                    NSString *html = [[NSString alloc] initWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:[url stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]]] encoding:enc];
                    
                    if (html == NULL) {
                        html = [[NSString alloc] initWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:[url stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]]] encoding:NSUTF8StringEncoding];
                        
                    }
                    
                    if ([[textView text]hasSuffix:@"html"] || [[textView text]hasSuffix:@"htm"]) {
                        
                        
                        NSString *result = [[NSString alloc] init];
                        NSString *start = @"<title>";
                        NSString *end = @"</title>";
                        NSRange rangeStart,rangeEnd;
                        rangeStart = [html rangeOfString:start];
                        rangeEnd = [html rangeOfString:end];
                        
                        result = [self cutNSString:html FromLocation:(rangeStart.location + rangeStart.length + 1) To:rangeEnd.location];
                        result = [self replaceHTMLCodeWithReadableString:result];
                        [html writeToFile:[NSString stringWithFormat:@"%@/%@.html",[self.paths lastObject],result] atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    }else{
                        //
                        needName = [[SLGlowingTextField alloc] initWithFrame:CGRectMake(20, 80, 242, 30)];
                        if ([[HTMLData language]hasPrefix:@"zh"]) {
                            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"请输入文件名\n\n\n" delegate:self cancelButtonTitle:@"取消" otherButtonTitles:@"好的", nil];
                            if (IOS_VERSION > 6.2) {
                                [alert setAlertViewStyle:UIAlertViewStylePlainTextInput];
                            }
                            [alert addSubview:needName];
                            [alert setDelegate:self];
                            [alert show];
                        }else{
                            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Warning" message:@"Please enter filename\n\n\n" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil];
                            if (IOS_VERSION > 6.2) {
                                [alert setAlertViewStyle:UIAlertViewStylePlainTextInput];
                            }
                            [alert addSubview:needName];
                            [alert setDelegate:self];
                            [alert show];
                        }
                        
                        contentOfHTML = [[NSString alloc] initWithFormat:@"%@",html];
                        //html
                        
                    }
                    
                }
            }
        }
    }
    [fileType setSelectedSegmentIndex:1];
}

- (void)startServerAtPath:(NSString *)path{
    [DDLog addLogger:[DDTTYLogger sharedInstance]];
	
	// Create server using our custom MyHTTPServer class
	httpServer = [[HTTPServer alloc] init];
	
	// Tell the server to broadcast its presence via Bonjour.
	// This allows browsers such as Safari to automatically discover our service.
	[httpServer setType:@"_http._tcp."];
	
	// Normally there's no need to run our server on any specific port.
	// Technologies like Bonjour allow clients to dynamically discover the server's port at runtime.
	// However, for easy testing you may want force a certain port so you can just hit the refresh button.
    NSInteger port;
    NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
    if ([d valueForKey:@"Port"] == NULL) {
        port = 80;
    }else{
        port = [[d valueForKey:@"Port"] integerValue];
    }
    [httpServer setPort:port];
	
	// Serve files from our embedded Web folder
	NSString *webPath = path;
	
	[httpServer setDocumentRoot:webPath];
    
    [self startServer];
    
}

- (void)stopTheServer{
    [httpServer stop];
}

- (NSString *)WiFiIPAddress{
    NSString *result = nil;
    struct ifaddrs *interfaces;
    char str[INET_ADDRSTRLEN];
    if (getifaddrs(&interfaces))
        return nil;
    struct ifaddrs *test_addr = interfaces;
    while (test_addr) {
        if(test_addr->ifa_addr->sa_family == AF_INET) {
            if (strcmp(test_addr->ifa_name, "en0") == 0) {
                inet_ntop(AF_INET, &((struct sockaddr_in *)test_addr->ifa_addr)->sin_addr, str, INET_ADDRSTRLEN);
                result = [NSString stringWithUTF8String:str];
                break;
            }
        }
        test_addr = test_addr->ifa_next;
    }
    freeifaddrs(interfaces);
    return result;
}

- (void)starttheserver:(HTMLWiFi *)sender{
    if ([self WiFiIPAddress] == NULL) {
        SIAlertView *alert;
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"现在没有连接到WiFi, 请连接到WiFi后再开启服务:)"]];
            [alert addButtonWithTitle:@"好的" type:SIAlertViewButtonTypeDestructive handler:nil];
            
        }else{
            alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"Not Connected To WiFi, please connect to WiFi and then you can start the server:)"]];
            [alert addButtonWithTitle:@"OK" type:SIAlertViewButtonTypeDestructive handler:nil];
        }
        [alert show];
        return;
    }
    if (isRootView) {
        if (sender.wifiOn == NO) {
            HTMLPicker_iPad *picker = [[HTMLPicker_iPad alloc] initWithNibName:@"HTMLPicker_iPad" bundle:nil];
            NSMutableArray *images = [[NSMutableArray alloc] initWithCapacity:[self.fileList count]];
            NSMutableArray *names = [[NSMutableArray alloc] initWithCapacity:[self.fileList count]];
            for (int i = 0; i < [self.fileList count]; i++) {
                [images addObject:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"folderPicker" ofType:@"png"]]];
                [names addObject:[self.fileList objectAtIndex:i]];
            }
            [picker setDelegate:self];
            picker.images = images;
            picker.names = names;
            [self presentViewController:picker animated:YES completion:nil];
        }else{
            SIAlertView *alert;
            if ([[HTMLData language] hasPrefix:@"zh"]) {
                alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"你确定要停止服务吗?"]];
                [alert addButtonWithTitle:@"取消" type:SIAlertViewButtonTypeCancel handler:nil];
                [alert addButtonWithTitle:@"停止服务" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView) {
                    [self stopTheServer];
                    [sender setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI" ofType:@"png"]] forState:UIControlStateNormal];
                    [sender setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI" ofType:@"png"]] forState:UIControlStateHighlighted];
                    sender.wifiOn = NO;
                }];
                
            }else{
                alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"Sure to stop the HTTP service?"]];
                [alert addButtonWithTitle:@"Cancel" type:SIAlertViewButtonTypeCancel handler:nil];
                [alert addButtonWithTitle:@"Stop It" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView) {
                    [self stopTheServer];
                    [sender setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI" ofType:@"png"]] forState:UIControlStateNormal];
                    [sender setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI" ofType:@"png"]] forState:UIControlStateHighlighted];
                    sender.wifiOn = NO;
                }];
                
            }
            [alert show];
            
            
        }
    }else if (sender.wifiOn == NO) {
        [self startServerAtPath:nowPath];
        [sender setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI_e" ofType:@"png"]] forState:UIControlStateNormal];
        [sender setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI_e" ofType:@"png"]] forState:UIControlStateHighlighted];
        sender.wifiOn = YES;
        
        SIAlertView *alert;
        NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            
            if ([d valueForKey:@"Port"] == NULL || [[d valueForKey:@"Port"] integerValue] == 80) {
                alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"在浏览器中打开\nhttp://%@\n即可浏览网页",[self WiFiIPAddress]]];
            }else{
                alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"在浏览器中打开\nhttp://%@:%@\n即可浏览网页",[self WiFiIPAddress],[d valueForKey:@"Port"]]];
            }
            
            [alert addButtonWithTitle:@"好的" type:SIAlertViewButtonTypeCancel handler:nil];
        }else{
            if ([d valueForKey:@"Port"] == NULL || [[d valueForKey:@"Port"] integerValue] == 80) {
                alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"Done! Open this link\nhttp://%@\nin browser.",[self WiFiIPAddress]]];
            }else{
                alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"Done! Open this link\nhttp://%@:%@\nin browser.",[self WiFiIPAddress],[d valueForKey:@"Port"]]];
            }
            
            [alert addButtonWithTitle:@"OK" type:SIAlertViewButtonTypeCancel handler:nil];
        }
        [alert show];
        
    }else{
        SIAlertView *alert;
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"你确定要停止服务吗?"]];
            [alert addButtonWithTitle:@"取消" type:SIAlertViewButtonTypeCancel handler:nil];
            [alert addButtonWithTitle:@"停止服务" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView) {
                [self stopTheServer];
                [sender setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI" ofType:@"png"]] forState:UIControlStateNormal];
                [sender setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI" ofType:@"png"]] forState:UIControlStateHighlighted];
                sender.wifiOn = NO;
            }];
            
        }else{
            alert = [[SIAlertView alloc] initWithTitle:@"Service" andMessage:[NSString stringWithFormat:@"Sure To Stop The HTTP Service?"]];
            [alert addButtonWithTitle:@"Cancel" type:SIAlertViewButtonTypeCancel handler:nil];
            [alert addButtonWithTitle:@"Stop It" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView) {
                [self stopTheServer];
                [sender setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI" ofType:@"png"]] forState:UIControlStateNormal];
                [sender setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI" ofType:@"png"]] forState:UIControlStateHighlighted];
                sender.wifiOn = NO;
            }];
            
        }
        [alert show];
    }
}

- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView1

{
        return image1;

    //返回ScrollView上添加的需要缩放的视图
}

- (void)saved{
    self.fileList = [HTMLData fileList:[self.paths lastObject]];
    NSMutableArray *tmp = [[NSMutableArray alloc] init];
    for (NSString *file in self.fileList) {
        if ([file isEqualToString:@"tmpCL3275OpxuJS8tDBW844SD.html"]) {
            
        }else{
            [tmp addObject:file];
        }
    }
    self.fileList = tmp;
    [iPhoneTableView reloadData];
    [UIView animateWithDuration:0.3 animations:^{
        for (UIView *view in [self.view subviews]) {
            if (view == self.uploadFile) {
                
            }else{
                view.alpha = 1;
            }
        }
    }];
}

- (void)loadSettings{
    NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
    [keepLit setOn:[[NSString stringWithFormat:@"%@",[d valueForKey:@"KeepLit"]] boolValue] animated:NO];
    [keepLitWhenServer setOn:[[NSString stringWithFormat:@"%@",[d valueForKey:@"KeepLitWhenServer"]] boolValue] animated:NO];
    [keepLitWhenPower setOn:[[NSString stringWithFormat:@"%@",[d valueForKey:@"KeepLitWhenPower"]] boolValue] animated:NO];
    if (keepLit.on) {
        if (keepLitWhenServer.on || keepLitWhenPower.on) {
            [timer setFireDate:[NSDate distantFuture]];
            timer = [NSTimer scheduledTimerWithTimeInterval:30 target:self selector:@selector(littime) userInfo:nil repeats:YES];
            [timer setFireDate:[NSDate distantPast]];
            [timer fire];
        }else{
            [UIApplication sharedApplication].idleTimerDisabled=YES;
        }
    }
}

#define iPhone5 ([UIScreen instancesRespondToSelector:@selector(currentMode)] ? CGSizeEqualToSize(CGSizeMake(640, 1136), [[UIScreen mainScreen] currentMode].size) : NO)

- (void)nextPic{
    if (pic == 1) {
        [UIView animateWithDuration:0.4 animations:^(void){
            if ([[HTMLData language] hasPrefix:@"zh"]) {
                tip.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"tip2-iPad" ofType:@"png"]];
            }else{
                tip.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"tip2-e-iPad" ofType:@"png"]];
            }
        }];
        pic = 2;
    }else if (pic == 2){
        [UIView animateWithDuration:0.4 animations:^(void){
            if ([[HTMLData language] hasPrefix:@"zh"]) {
                tip.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"tip3-iPad" ofType:@"png"]];
            }else{
                tip.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"tip3-e-iPad" ofType:@"png"]];
            }
        }];
        pic = 3;
    }else{
        [UIView animateWithDuration:0.4 animations:^(void){
            [tip setHidden:YES];
            [tip setUserInteractionEnabled:NO];
            [tip removeFromSuperview];
        }];
        pic = 4;
        [tip removeFromSuperview];
        NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
        [d setValue:@"Pass" forKey:@"firstTime"];
        [firstTime setFireDate:[NSDate distantFuture]];
        [firstTime invalidate];
    }
}

- (NSDictionary *)codeSend{
    return codeinfo;
}

- (void)viewDidLoad
{
    [self prepareFile];
    [self setUI];
    
    [self setUpNotification];
    
    moviePlayer = [[MPMoviePlayerController alloc]init];
    
    UISwipeGestureRecognizer *left = [[UISwipeGestureRecognizer alloc] initWithTarget:self action:@selector(back)];
    [left setNumberOfTouchesRequired:1];
    [left setDirection:UISwipeGestureRecognizerDirectionRight];
    [self.view addGestureRecognizer:left];
    
    myCode = [HTMLCodeSend shared];
    [myCode setSenderDelegate:self];
    
    if ([[HTMLData language] hasPrefix:@"zh"]) {
    }else{
        [keepLitLabel setText:@"Keep screen lit"];
        [keepLitWhenPowerLabel setText:@"Only when charging"];
        [keepLitWhenServerLabel setText:@"Only when servicing"];
    }

    
    NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
    if ([d valueForKey:@"firstTime"] == NULL) {
        NSFileManager *manager = [NSFileManager defaultManager];
        NSString *path = [docPath stringByAppendingFormat:@"/Hello World"];
        
        NSError *error = nil;
        [manager createDirectoryAtPath:path withIntermediateDirectories:NO attributes:nil error:&error];
        NSString *path1 = path;
        path = [path stringByAppendingFormat:@"/Hello_World.html"];
        
        NSString *htmlContent = [NSString stringWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"Hello_World" ofType:@"html"] encoding:NSUTF8StringEncoding error:nil];
        
        NSString *content = [NSString stringWithFormat:@"<title>%@ - %@ %@</title>\n%@",[[UIDevice currentDevice] name],[[UIDevice currentDevice] systemName],[[UIDevice currentDevice] systemVersion],htmlContent];
        
        if ([[HTMLData language]hasPrefix:@"zh"]) {
            [manager createFileAtPath:path contents:[content dataUsingEncoding:NSUTF16StringEncoding] attributes:nil];
        }else{
            [manager createFileAtPath:path contents:[content dataUsingEncoding:NSUTF8StringEncoding] attributes:nil];
        }
        
        
        
        [manager copyItemAtPath:[NSString stringWithFormat:@"%@/Power HTML.app/mode-c_cpp.js",NSHomeDirectory()] toPath:[docPath stringByAppendingFormat:@"/Hello World/mode-c_cpp.js"] error:nil];
        [manager copyItemAtPath:[NSString stringWithFormat:@"%@/Power HTML.app/jquery-1.9.0.min.js",NSHomeDirectory()] toPath:[docPath stringByAppendingFormat:@"/Hello World/jquery-1.9.0.min.js"] error:nil];
        [manager copyItemAtPath:[NSString stringWithFormat:@"%@/Power HTML.app/ace.js",NSHomeDirectory()] toPath:[docPath stringByAppendingFormat:@"/Hello World/ace.js"] error:nil];
        [manager copyItemAtPath:[NSString stringWithFormat:@"%@/Power HTML.app/theme-tomorrow_night_eighties.js",NSHomeDirectory()] toPath:[docPath stringByAppendingFormat:@"/Hello World/theme-tomorrow_night_eighties.js"] error:nil];
        
        [d setValue:@"Hello_World.html" forKey:path1];
        
        self.fileList = [HTMLData fileList:docPath];
        [iPhoneTableView reloadData];
        
        
        tip = [[UIImageView alloc] initWithFrame:self.view.bounds];
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            tip.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"tip1-iPad" ofType:@"png"]];
        }else{
            tip.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"tip1-e-iPad" ofType:@"png"]];
        }
        
        
        [self.view addSubview:tip];
        pic = 1;
        
        firstTime = [NSTimer scheduledTimerWithTimeInterval:3.0 target:self selector:@selector(nextPic) userInfo:nil repeats:YES];
        [firstTime setFireDate:[NSDate dateWithTimeIntervalSinceNow:2]];
        //[firstTime fire];
    }
    
    [super viewDidLoad];
    
    [[NSNotificationCenter defaultCenter]
     addObserver:self selector:@selector(saved) name:@"saved" object:nil];
    
    device = [UIDevice currentDevice];
    device.batteryMonitoringEnabled = YES;
    
    [self loadSettings];
    
    
    fileType = [[HMSegmentedControl alloc] initWithSectionTitles:@[@"From Web",@"html",@"css", @"js",@"htm"]];
    [fileType setSelectedSegmentIndex:0];
    [fileType setFrame:CGRectMake(35, 310, 440, 45)];
    
    containerView = [[HMSegmentedControlContainerView alloc] initWithHMSegmentedControl:fileType];
    [self.view addSubview:containerView];
    [containerView setHidden:YES];
    [containerView setUserInteractionEnabled:NO];
    
    isRootView = YES;
    paths = [[NSMutableArray alloc] init];
    [paths addObject:docPath];
    
    toolbar = [[UIImageView alloc]initWithFrame:CGRectMake(0, self.view.frame.size.height - 44, self.view.frame.size.width, 44)];
    toolbar.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"toolbar_background" ofType:@"png"]];
    [toolbar setAutoresizingMask:UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleRightMargin|UIViewAutoresizingFlexibleWidth|UIViewAutoresizingFlexibleBottomMargin|UIViewAutoresizingFlexibleTopMargin];
    
    backBtn = [[UIImageView alloc]initWithFrame:CGRectMake(14, 10, 30, 30)];
    backBtn.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"toolbar_back@2x" ofType:@"png"]];
    [backBtn setAutoresizingMask:UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleRightMargin];
    backBtn.userInteractionEnabled = YES;
    toolbar.userInteractionEnabled = YES;
    UITapGestureRecognizer *onetap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(back)];
    [backBtn setTag:12];
    [backBtn addGestureRecognizer:onetap];
    
    
    [toolbar addSubview:backBtn];
    [self.view addSubview:toolbar];
    [backBtn setHidden:YES];
    
    newbtn = [[UIButton alloc]initWithFrame:CGRectMake(9, 0, 40, 45)];
    [newbtn setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"new" ofType:@"png"]] forState:UIControlStateNormal];
    [newbtn setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"new_c" ofType:@"png"]] forState:UIControlStateHighlighted];
    [newbtn addTarget:self action:@selector(cnew) forControlEvents:UIControlEventTouchUpInside];
    [newbtn setAutoresizingMask:UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleRightMargin];
    [newbtn setTag:11];
    [toolbar addSubview:newbtn];
    
    
    addFile = [[UIButton alloc]initWithFrame:CGRectMake(220, 9, 20, 25)];
    [addFile setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"item-icon-file-selected" ofType:@"png"]] forState:UIControlStateNormal];
    [addFile addTarget:self action:@selector(addFileBtn) forControlEvents:UIControlEventTouchUpInside];
    [addFile setAutoresizingMask:UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleRightMargin];
    [addFile setTag:8];
    [toolbar addSubview:addFile];
    [addFile setHidden:YES];
    
    point.x = 230;
    point.y = 712;
    
    
    photoDetail = [[HTMLPhotoView alloc] initWithNibName:nil bundle:nil];
    
    newbtn1 = [[UIButton alloc]initWithFrame:CGRectMake(self.view.frame.size.width/2-20, 0, 40, 45)];
    [newbtn1 setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"new" ofType:@"png"]] forState:UIControlStateNormal];
    [newbtn1 setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"new_c" ofType:@"png"]] forState:UIControlStateHighlighted];
    [newbtn1 addTarget:self action:@selector(cnew1) forControlEvents:UIControlEventTouchUpInside];
    [newbtn1 setAutoresizingMask:UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleRightMargin];
    [toolbar addSubview:newbtn1];
    [newbtn1 setTag:8];
    [newbtn1 setHidden:YES];
    
    
    enableWIFI = [[HTMLWiFi alloc] initWithFrame:CGRectMake(self.view.frame.size.width - 60, 0, 40, 45)];
    [enableWIFI setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"WIFI" ofType:@"png"]] forState:UIControlStateNormal];
    [enableWIFI addTarget:self action:@selector(starttheserver:) forControlEvents:UIControlEventTouchUpInside];
    [enableWIFI setAutoresizingMask:UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleRightMargin];
    [enableWIFI setTag:7];
    [toolbar addSubview:enableWIFI];
    
    imageS.contentSize = CGSizeMake(600, 500);
    
    settings = [[UIButton alloc]initWithFrame:CGRectMake(self.view.frame.size.width - 120, 0, 40, 45)];
    [settings setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"settings" ofType:@"png"]] forState:UIControlStateNormal];
    [settings addTarget:self action:@selector(settingsbtn:) forControlEvents:UIControlEventTouchUpInside];
    [settings setAutoresizingMask:UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleRightMargin];
    [settings setTag:80];
    [toolbar addSubview:settings];
    
    [keepLit setHidden:YES];
    [keepLit setUserInteractionEnabled:YES];
    [keepLit setTag:0];
    [keepLit addTarget:self action:@selector(lit:) forControlEvents:UIControlEventValueChanged];
    
    [keepLitWhenServer setHidden:YES];
    [keepLitWhenServer setUserInteractionEnabled:YES];
    [keepLitWhenServer setTag:1];
    [keepLitWhenServer addTarget:self action:@selector(lit:) forControlEvents:UIControlEventValueChanged];
    
    [keepLitWhenPower setHidden:YES];
    [keepLitWhenPower setUserInteractionEnabled:YES];
    [keepLitWhenPower setTag:2];
    [keepLitWhenPower addTarget:self action:@selector(lit:) forControlEvents:UIControlEventValueChanged];
    
    [keepLitWhenPowerLabel setHidden:YES];
    [keepLitLabel setHidden:YES];
    [keepLitWhenServerLabel setHidden:YES];
    [bg setHidden:YES];
    
    nowPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES) objectAtIndex:0];
	[self.view setBackgroundColor:[UIColor colorWithRed:1 green:0.976 blue:0.957 alpha:1]];
    
    iPhoneTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, 1024, 768 - 20) style:UITableViewStylePlain];
    
    CGRect frame1  = iPhoneTableView.frame;
    frame1.size.height -= 44;
    iPhoneTableView.frame = frame1;
    
    iPhoneTableView.tag = 626;
    [iPhoneTableView setAutoresizingMask:UIViewAutoresizingFlexibleWidth|UIViewAutoresizingFlexibleHeight];
    [iPhoneTableView setBackgroundColor:[UIColor clearColor]];
    [iPhoneTableView setSeparatorStyle:UITableViewCellSeparatorStyleNone];
    [iPhoneTableView setDelegate:(id<UITableViewDelegate>)self];
    [iPhoneTableView setDataSource:(id<UITableViewDataSource>)self];
    [iPhoneTableView setShowsHorizontalScrollIndicator:NO];
    
    CGRect rect = self.view.bounds;
    rect.size.width = 1200;
	rect.origin.y = 0;
    rect.size.height = 3;
    
    shadowViewBottom = [[UIView alloc] initWithFrame:rect];
    
    UIBezierPath *shadowPath = [UIBezierPath bezierPathWithRect:shadowViewBottom.frame];
    [shadowViewBottom.layer setMasksToBounds:YES];
	[shadowViewBottom.layer setShadowColor:[UIColor blackColor].CGColor];
	[shadowViewBottom.layer setShadowOffset:CGSizeMake(0.0f, -2.0f)];
    [shadowViewBottom.layer setShadowOpacity:0.55f];
    [shadowViewBottom.layer setShadowRadius:5.0f];
    [shadowViewBottom.layer setShadowPath:shadowPath.CGPath];
	
    [iPhoneTableView setTableFooterView:shadowViewBottom];
    [self.view addSubview:iPhoneTableView];
    
    rect = CGRectMake(0, -20, 1200, 20);
    shadowViewTop = [[UIView alloc] initWithFrame:rect];
    
    [self.view addSubview:shadowViewTop];
    
	rect.origin.y = 20;
    rect.size.height = 3;
    shadowPath = [UIBezierPath bezierPathWithRect:rect];
    [shadowViewTop.layer setMasksToBounds:YES];
	[shadowViewTop.layer setShadowColor:[UIColor blackColor].CGColor];
	[shadowViewTop.layer setShadowOffset:CGSizeMake(0.0f, -2.0f)];
	[shadowViewTop.layer setShadowOpacity:0.55f];
	[shadowViewTop.layer setShadowRadius:5.0f];
	[shadowViewTop.layer setShadowPath:shadowPath.CGPath];
    
    rect = CGRectMake(-20, 0, 1200, 20);
    UIView *shadowView = [[UIView alloc] initWithFrame:rect];
    [self.view addSubview:shadowView];
	
    [scrollView setTag:79];
    
    [self configSrcollView];
    [scrollView setHidden:YES];
    
    image1 = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 600, 500)];
    
    rect.origin.y = 0;
    rect.size.height = 3;
	
    shadowPath = [UIBezierPath bezierPathWithRect:rect];
    [shadowView.layer setMasksToBounds:NO];
	[shadowView.layer setShadowColor:[UIColor blackColor].CGColor];
	[shadowView.layer setShadowOffset:CGSizeMake(0.0f, -2.0f)];
	[shadowView.layer setShadowOpacity:0.55f];
	[shadowView.layer setShadowRadius:3.0f];
	[shadowView.layer setShadowPath:shadowPath.CGPath];
    
    [shadowViewTop setAutoresizingMask:UIViewAutoresizingFlexibleWidth];
    [shadowViewBottom setAutoresizingMask:UIViewAutoresizingFlexibleWidth];
    
    
    imageS = [[UIScrollView alloc] initWithFrame:CGRectMake(0, 0, 600, 500)];
    [imageS setBackgroundColor:[UIColor clearColor]];
    UITapGestureRecognizer *two = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(zoomS)];
    [two setNumberOfTapsRequired:2];
    [two setNumberOfTouchesRequired:1];
    [imageS addGestureRecognizer:two];
    [imageS setMaximumZoomScale:8];
    [imageS setMinimumZoomScale:1];
    [imageS setTag:888];
    [imageS setDelegate:self];
    [imageS addSubview:image1];
    
    UITapGestureRecognizer *one = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(detailView)];
    [one setNumberOfTapsRequired:1];
    [one setNumberOfTouchesRequired:1];
    [one requireGestureRecognizerToFail:two];
    [imageS addGestureRecognizer:one];
    
    
    musicView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 280, 80)];
    [musicView setBackgroundColor:[UIColor whiteColor]];
    
    play = [UIButton buttonWithType:UIButtonTypeCustom];
    [play setFrame:CGRectMake(125, 20, 25, 25)];
    [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPlay" ofType:@"png"]] forState:UIControlStateNormal];
    [play addTarget:self action:@selector(playMusicBtn:) forControlEvents:UIControlEventTouchUpInside];
    
    [musicView addSubview:play];
    
    
    fastforward = [UIButton buttonWithType:UIButtonTypeCustom];
    [fastforward setFrame:CGRectMake(205, 20, 30, 25)];
    [fastforward setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerFastForward" ofType:@"png"]] forState:UIControlStateNormal];
    [fastforward addTarget:self action:@selector(fastforwardBtn:) forControlEvents:UIControlEventTouchDragOutside];
    
    [musicView addSubview:fastforward];
    
    
    
    rewind = [UIButton buttonWithType:UIButtonTypeCustom];
    [rewind setFrame:CGRectMake(45, 20, 30, 25)];
    [rewind setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerRewind" ofType:@"png"]] forState:UIControlStateNormal];
    [rewind addTarget:self action:@selector(rewindBtn:) forControlEvents:UIControlEventTouchDragOutside];
    
    [musicView addSubview:rewind];
    
    self.panel = [AJProgressPanel showInView:musicView position:AJPanelPositionBottom];
    self.panel.progressColor = [UIColor colorWithRed:50.0f/255 green:170.0f/255 blue:193.0f/255 alpha:0.7f];
    
    self.uploadFile = [AJProgressPanel showInMyView:self.view position:AJPanelPositionBottom];
    self.uploadFile.progressColor = [UIColor colorWithRed:50.0f/255 green:170.0f/255 blue:193.0f/255 alpha:0.7f];
    self.uploadFile.alpha = 0.0;
    [self.uploadFile setProgress:0.0 animated:NO];
    self.uploadFile.tag = 10030;
    
    
    dropbox = [[FlatPillButton alloc] initWithFrame:CGRectMake(20, 376, 984, 35)];
    UIFont *font = [UIFont fontWithName:@"Avenir-Black" size:18.0];
    if ([[DBSession sharedSession] isLinked]) {
        [self.dropbox setTitle:[[[DBSession sharedSession]userIds] objectAtIndex:0]  forState:UIControlStateNormal];
    }else{
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            [self.dropbox setTitle:@"链接Dropbox"  forState:UIControlStateNormal];
        }else{
            [self.dropbox setTitle:@"Link"  forState:UIControlStateNormal];
        }
    }
    
    self.dropbox.titleLabel.font = font;
    
    [self.dropbox setTitleColor:[UIColor colorWithRed:0.0 green:0.4 blue:0.77 alpha:0.85] forState:UIControlStateNormal];
    
    [self.dropbox addTarget:self action:@selector(dropboxBtn) forControlEvents:UIControlEventTouchUpInside];
    
    [self.scrollView addSubview:dropbox];
    
    
    dropboxFolder = [[FlatPillButton alloc] initWithFrame:CGRectMake(20, 421, 984, 35)];
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        [self.dropboxFolder setTitle:@"查看Dropbox"  forState:UIControlStateNormal];
    }else{
        [self.dropboxFolder setTitle:@"View Dropbox"  forState:UIControlStateNormal];
    }
    
    self.dropboxFolder.titleLabel.font = font;
    
    [self.dropboxFolder setTitleColor:[UIColor colorWithRed:0.0 green:0.4 blue:0.77 alpha:0.85] forState:UIControlStateNormal];
    
    [self.dropboxFolder addTarget:self action:@selector(switchToDropbox) forControlEvents:UIControlEventTouchUpInside];
    
    [self.scrollView addSubview:dropboxFolder];
    
    if (![[DBSession sharedSession] isLinked]) {
        self.dropboxFolder.enabled = NO;
        self.dropboxFolder.alpha = 0.7;
    }

    static dispatch_once_t predicate;
    dispatch_once(&predicate, ^{
        zip = [[ZipArchive alloc] init];
        self.FLACplayer = [[ORGMEngine alloc] init];
        self.FLACplayer.delegate = self;
        
    });
    
}

- (NSURL *)engineExpectsNextUrl:(ORGMEngine *)engine{
    return nil;
}

- (void)engine:(ORGMEngine *)engine didChangeState:(ORGMEngineState)state{
    switch (state) {
        case ORGMEngineStateStopped: {
            [self.panel setProgress:0.0 animated:YES];
            [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPlay" ofType:@"png"]] forState:UIControlStateNormal];
            break;
        }
        case ORGMEngineStatePaused: {
            
            break;
        }
        case ORGMEngineStatePlaying: {
            metadata = nil;
            metadata = [[NSDictionary alloc] initWithDictionary:[self.FLACplayer metadata] copyItems:YES];
            
            /*
             album
             totaltracks
             album artist
             catalog
             artist
             date
             tracknumber
             discid
             title
             */
            
            break;
        }
        case ORGMEngineStateError:
            break;
    }
    
}

- (void)switchToDropbox{
    static dispatch_once_t predicate;
    dispatch_once(&predicate, ^{
        nav = [[NaviViewController alloc] init];
        UIViewController *d = [UIViewController new];
        [nav pushViewController:d animated:NO];
        
    });
    DropboxViewController *dropboxView = [[DropboxViewController alloc] initWithNibName:@"DropboxViewController_iPad" bundle:nil];
    
    
    [nav pushViewController:dropboxView animated:NO];
    [self presentViewController:nav animated:YES completion:nil];
}

- (void)getOutFromDropbox{
    [nav dismiss];
}

- (void)detailView{
    photoDetail.image = image1.image;
    [photoDetail updateImageView];
    [self presentViewController:photoDetail animated:YES completion:^(void){
    }];
}

- (void)unzip:(HTMLCell *)cell{

    if ([[HTMLData language]hasPrefix:@"zh"]) {
        [SVProgressHUD showWithStatus:@"正在解压文件" maskType:SVProgressHUDMaskTypeClear];
    }else{
        [SVProgressHUD showWithStatus:@"unziping files" maskType:SVProgressHUDMaskTypeClear];
    }
    NSString *folder = [cell.filename.text pathExtension];
    
    NSFileManager *manager = [NSFileManager defaultManager];
    BOOL isDir = NO;
    if ([manager fileExistsAtPath:[[self.paths lastObject] stringByAppendingFormat:@"/%@",[cell.filename.text substringToIndex:[[cell.filename text] length] - [folder length] - 1]] isDirectory:&isDir]) {
        
    }else{
        [manager createDirectoryAtPath:[[self.paths lastObject] stringByAppendingFormat:@"/%@",[cell.filename.text substringToIndex:[[cell.filename text] length] - [folder length] - 1]] withIntermediateDirectories:NO attributes:nil error:nil];
    }
    
    
    NSString *unZipTo = [[self.paths lastObject] stringByAppendingFormat:@"/%@/",[cell.filename.text substringToIndex:[[cell.filename text] length] - [folder length] - 1]];
    if ([zip UnzipOpenFile:cell.filePath]) {
        [zip UnzipFileTo:unZipTo overWrite:YES];
        
        [zip UnzipCloseFile];
    }
    /*
     ZipFile *zFile = [[ZipFile alloc] initWithFileName:cell.filePath mode:ZipFileModeUnzip];
     NSInteger done = 0;
     CGContextRef context = UIGraphicsGetCurrentContext();
     [UIView beginAnimations:@"animationID" context:context];
     [UIView setAnimationDuration:0.5f];
     [UIView setAnimationDelegate:self];
     self.uploadFile.alpha = 1.0;
     [UIView commitAnimations];
     [self.uploadFile setProgress:0.0 animated:NO];
     BOOL bContinue = [zFile goToFirstFileInZip];
     while (bContinue) {
     FileInZipInfo *fInfo = [zFile currentFileInZipInfo];
     
     ZipReadStream *readStream = [zFile readCurrentFileInZip];
     
     NSMutableData *data = [[NSMutableData alloc] initWithData:[readStream readDataOfLength:fInfo.length]];
     
     [readStream finishedReading];
     
     NSFileManager *manager = [NSFileManager defaultManager];
     BOOL isDir = NO;
     if ([manager fileExistsAtPath:[docPath stringByAppendingFormat:@"/My Dropbox/%@",[cell.filename.text substringToIndex:[[cell.filename text] length] - [folder length] - 1]] isDirectory:&isDir]) {
     
     }else{
     [manager createDirectoryAtPath:[docPath stringByAppendingFormat:@"/My Dropbox/%@",[cell.filename.text substringToIndex:[[cell.filename text] length] - [folder length] - 1]] withIntermediateDirectories:NO attributes:nil error:nil];
     }
     [data writeToFile:[docPath stringByAppendingFormat:@"/My Dropbox/%@/%@",[cell.filename.text substringToIndex:[[cell.filename text] length] - [folder length] - 1], fInfo.name] atomically:YES];
     done += 1;
     [self.uploadFile setProgress:(done/1.0)/zFile.numFilesInZip animated:YES];
     bContinue = [zFile goToNextFileInZip];
     
     }
     [zFile close];
     CGContextRef context1 = UIGraphicsGetCurrentContext();
     [UIView beginAnimations:@"animationID" context:context1];
     [UIView setAnimationDuration:0.5f];
     [UIView setAnimationDelegate:self];
     self.uploadFile.alpha = 0.0;
     [UIView commitAnimations];
     [self.uploadFile setProgress:0.0 animated:NO];
     */
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        [SVProgressHUD showSuccessWithStatus:@"解压完成" duration:1];
    }else{
        [SVProgressHUD showSuccessWithStatus:@"Succeeded!" duration:1];
    }
    
    [self updateTable];
}

-(void)configNowPlayingInfoCenterFLAC{
    
    if (NSClassFromString(@"MPNowPlayingInfoCenter")) {
        
        /*
         album
         totaltracks
         album artist
         catalog
         artist
         date
         tracknumber
         discid
         title
         */
        NSString *title = [metadata valueForKey:@"title"];
        if (title == nil) {
            title = @" ";
        }
        
        NSString *artist = [metadata valueForKey:@"artist"];
        if (artist == nil) {
            artist = @" ";
        }
        
        NSString *album = [metadata valueForKey:@"album"];
        if (album == nil) {
            album = @" ";
        }
        
        
        NSMutableDictionary *dict = [[NSMutableDictionary alloc] init];
        [dict setObject:title  forKey:MPMediaItemPropertyTitle];
        [dict setObject:artist forKey:MPMediaItemPropertyArtist];
        [dict setObject:album forKey:MPMediaItemPropertyAlbumTitle];
        
        UIImage *image;
        if ([metadata valueForKey:@"picture"] == nil) {
            image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"icon" ofType:@"png"]];
        }else{
            image = [UIImage imageWithData:[metadata valueForKey:@"picture"]];
        }
        
        
        MPMediaItemArtwork *artwork = [[MPMediaItemArtwork alloc] initWithImage:image];
        [dict setObject:artwork forKey:MPMediaItemPropertyArtwork];
        
        [[MPNowPlayingInfoCenter defaultCenter] setNowPlayingInfo:dict];
        
    }
    
}

- (void)playMusic:(HTMLCell *)cell{
    NSURL *musicURL = [NSURL fileURLWithPath:cell.filePath];
    if ([cell.filePath hasSuffix:@"flac"]) {
        //flac
        isFLAC = YES;
        [self.FLACplayer playUrl:musicURL];
        [[AVAudioSession sharedInstance] setCategory:AVAudioSessionCategoryPlayback error:nil];
        audioPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:nil
                                                             error:nil];
        [audioPlayer setDelegate:self];
        [audioPlayer play];
        
        /*
         album
         totaltracks
         album artist
         catalog
         artist
         date
         tracknumber
         discid
         title
         */
        
        
        
        CGPoint point1;
        if (iPhone5) {
            point1 = cell.frame.origin;
            CGPoint off = [iPhoneTableView contentOffset];
            point1.y = point1.y - off.y + 30;
            
        }else{
            point1 = cell.frame.origin;
            CGPoint off = [iPhoneTableView contentOffset];
            point1.y = point1.y - off.y + 30;
            
        }
        [pv dismiss];
        [updateDur invalidate];
        updateDur = [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(updateViewFLAC) userInfo:nil repeats:YES];
        [updateDur setFireDate:[NSDate dateWithTimeIntervalSinceNow:1]];
        
        [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPause" ofType:@"png"]] forState:UIControlStateNormal];
        
        musicPop = [PopoverView showPopoverAtPoint:point1 inView:self.view withTitle:@"Music" withContentView:musicView delegate:self];
        
        [NSTimer scheduledTimerWithTimeInterval:1.0 target:self selector:@selector(configNowPlayingInfoCenterFLAC) userInfo:nil repeats:NO];

    }else{
        [[AVAudioSession sharedInstance] setCategory:AVAudioSessionCategoryPlayback error:nil];
        audioPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:musicURL
                                                             error:nil];
        [audioPlayer setDelegate:self];
        CGPoint point1;
        if (iPhone5) {
            point1 = cell.frame.origin;
            CGPoint off = [iPhoneTableView contentOffset];
            point1.y = point1.y - off.y + 30;
            
        }else{
            point1 = cell.frame.origin;
            CGPoint off = [iPhoneTableView contentOffset];
            point1.y = point1.y - off.y + 30;
            
        }
        [pv dismiss];
        [updateDur invalidate];
        updateDur = [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(updateView) userInfo:nil repeats:YES];
        [audioPlayer prepareToPlay];
        [updateDur setFireDate:[NSDate dateWithTimeIntervalSinceNow:1]];
        [audioPlayer play];
        
        NSMutableDictionary *d = [[NSMutableDictionary alloc] initWithCapacity:3];
        [d setValue:cell.filename.text forKey:@"name"];
        [d setValue:@"" forKey:@"singer"];
        [d setValue:@"" forKey:@"album"];
        
        [self configNowPlayingInfoCenter:d];
        
        [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPause" ofType:@"png"]] forState:UIControlStateNormal];
        
        
        
        musicPop = [PopoverView showPopoverAtPoint:point1 inView:self.view withTitle:@"Music" withContentView:musicView delegate:self];
    }
    
}

- (void)dropboxBtn{
    if ([self.dropbox.titleLabel.text isEqualToString:@"Link"] || [self.dropbox.titleLabel.text isEqualToString:@"链接Dropbox"]) {
        [[DBSession sharedSession] unlinkUserId:[[[DBSession sharedSession] userIds] objectAtIndex:0]];
        [[DBSession sharedSession] linkFromController:self];
    }else{
        if ([serverPort isEditing]) {
            return;
        }else{
            SIAlertView *alert;
            if ([[HTMLData language]hasPrefix:@"zh"]) {
                alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"您确定要注销Dropbox吗?"];
                [alert addButtonWithTitle:@"是的" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
                    [[DBSession sharedSession] unlinkUserId:[[[DBSession sharedSession] userIds] objectAtIndex:0]];
                    [self.dropbox.titleLabel setText:@"链接Dropbox"];
                }];
                [alert addButtonWithTitle:@"取消" type:SIAlertViewButtonTypeDestructive handler:nil];
                [alert show];
            }else{
                alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"Sure to exit Dropbox?"];
                [alert addButtonWithTitle:@"Yes" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
                    [[DBSession sharedSession] unlinkUserId:[[[DBSession sharedSession] userIds] objectAtIndex:0]];
                    [self.dropbox.titleLabel setText:@"Link"];
                }];
                [alert addButtonWithTitle:@"Cancel" type:SIAlertViewButtonTypeDestructive handler:nil];
                [alert show];
            }
        }
    }
}



- (void)audioPlayerDidFinishPlaying:(AVAudioPlayer *)player successfully:(BOOL)flag{
    [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPlay" ofType:@"png"]] forState:UIControlStateNormal];
}

- (void)audioPlayerEndInterruption:(AVAudioPlayer *)player
{
    [audioPlayer play];
    
}

- (void)updateView{
    [self.panel setProgress:([audioPlayer currentTime]*1.0)/[audioPlayer duration] animated:YES];
}

- (void)updateViewFLAC{
    [self.panel setProgress:([self.FLACplayer amountPlayed]*1.0)/[self.FLACplayer trackTime] animated:YES];
    if ([self.FLACplayer amountPlayed] == [self.FLACplayer trackTime]) {
        [self.panel setProgress:0.0 animated:YES];
        [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPlay" ofType:@"png"]] forState:UIControlStateNormal];
        [updateDur setFireDate:[NSDate distantFuture]];
        [updateDur invalidate];
        [musicPop dismiss];
    }
}

- (void)rewindBtn:(UIButton *)sender{
    if (isFLAC) {
        NSTimeInterval time = [self.FLACplayer amountPlayed] - 3;
        [self.FLACplayer seekToTime:time];
        [self.panel setProgress:([self.FLACplayer amountPlayed]*1.0)/[self.FLACplayer trackTime] animated:YES];
    }else{
        NSTimeInterval time = [audioPlayer currentTime] - 3;
        [audioPlayer setCurrentTime:time];
        [self.panel setProgress:([audioPlayer currentTime]*1.0)/[audioPlayer duration] animated:YES];
    }
}

- (void)fastforwardBtn:(UIButton *)sender{
    if (isFLAC) {
        NSTimeInterval time = [self.FLACplayer amountPlayed] + 3;
        [self.FLACplayer seekToTime:time];
        [self.panel setProgress:([self.FLACplayer amountPlayed]*1.0)/[self.FLACplayer trackTime] animated:YES];
    }else{
        NSTimeInterval time = [audioPlayer currentTime] + 3;
        [audioPlayer setCurrentTime:time];
        [self.panel setProgress:([audioPlayer currentTime]*1.0)/[audioPlayer duration] animated:YES];
    }
    
}

- (void)playMusicBtn:(UIButton *)sender{
    if (isFLAC) {
        if (self.FLACplayer.currentState == ORGMEngineStatePaused) {
            [self.FLACplayer resume];
            [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPause" ofType:@"png"]] forState:UIControlStateNormal];
        } else if (self.FLACplayer.currentState == ORGMEngineStatePlaying) {
            [self.FLACplayer pause];
            [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPlay" ofType:@"png"]] forState:UIControlStateNormal];
        }
    }else{
        if ([audioPlayer isPlaying]) {
            [audioPlayer pause];
            [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPlay" ofType:@"png"]] forState:UIControlStateNormal];
        }else{
            [audioPlayer play];
            [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPause" ofType:@"png"]] forState:UIControlStateNormal];
        }
    }
    
}


- (void)zoomS{
    if (imageS.zoomScale < 3) {
        [imageS setZoomScale:8 animated:YES];
    }else{
        [imageS setZoomScale:1 animated:YES];
    }
    
}

- (void)settingsbtn:(UIButton *)sender{
    
    if (![[DBSession sharedSession] isLinked]) {
        self.dropboxFolder.enabled = NO;
        self.dropboxFolder.alpha = 0.7;
    }else{
        self.dropboxFolder.enabled = YES;
        self.dropboxFolder.alpha = 1.0;
    }
    
    if (sender.tag == 4) {
        [UIView animateWithDuration:0.3 animations:^{
            for (UIView *view in [self.view subviews]) {
                if (view.tag == 626) {
                    view.alpha = 0;
                }
            }
        }];
        sender.tag = 5;
        [UIView animateWithDuration:0.5
                              delay:0.2
                            options:UIViewAnimationOptionCurveEaseOut
                         animations:^{
                             [scrollView setHidden:NO];
                             [scrollView setUserInteractionEnabled:YES];
                             [keepLit setHidden:NO];
                             
                             
                             if ([[DBSession sharedSession] isLinked]) {
                                 if ([[HTMLData language] hasPrefix:@"zh"]) {
                                     [self.dropbox setTitle:@"    退出链接    "  forState:UIControlStateNormal];
                                 }else{
                                     [self.dropbox setTitle:@"    Unlink    "  forState:UIControlStateNormal];
                                 }
                             }else{
                                 if ([[HTMLData language] hasPrefix:@"zh"]) {
                                     [self.dropbox setTitle:@"  链接Dropbox  "  forState:UIControlStateNormal];
                                 }else{
                                     [self.dropbox setTitle:@"     Link     "  forState:UIControlStateNormal];
                                 }
                             }

                             
                             NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
                             
                             
                             [keepLitWhenServer setHidden:NO];
                             
                             
                             [keepLitWhenPower setHidden:NO];
                             
                             
                             [keepLit setOn:[[NSString stringWithFormat:@"%@",[d valueForKey:@"KeepLit"]] boolValue] animated:NO];
                             [keepLitWhenServer setOn:[[NSString stringWithFormat:@"%@",[d valueForKey:@"KeepLitWhenServer"]] boolValue] animated:NO];
                             [keepLitWhenPower setOn:[[NSString stringWithFormat:@"%@",[d valueForKey:@"KeepLitWhenPower"]] boolValue] animated:NO];
                             
                             keepLitWhenServer.userInteractionEnabled = keepLitWhenPower.userInteractionEnabled = keepLit.on;
                             
                             [UIView animateWithDuration:0.3f
                                                   delay:0.0f
                                                 options:UIViewAnimationOptionCurveEaseOut
                                              animations:^{
                                                  keepLitWhenPower.alpha = keepLitWhenServer.alpha = (keepLit.on ? 1.0f : 0.3f);
                                              } completion:nil];
                             
                             if (isRootView) {
                                 for (UIView *d in [toolbar subviews]) {
                                     if (d.tag == 7 || d.tag == 11) {
                                         [d setHidden:YES];
                                     }
                                 }
                             }else{
                                 for (UIView *d in [toolbar subviews]) {
                                     if (d.tag == 7 || d.tag == 8 || d.tag == 12) {
                                         [d setHidden:YES];
                                     }
                                 }
                             }
                             [keepLitWhenPowerLabel setHidden:NO];
                             [keepLitLabel setHidden:NO];
                             [keepLitWhenServerLabel setHidden:NO];
                             [bg setHidden:NO];
                         } completion:^(BOOL finished){
                             
                         }];
        
        
    }else{
        [UIView animateWithDuration:0.3 animations:^{
            for (UIView *view in [self.view subviews]) {
                if (view.tag == 626) {
                    view.alpha = 1;
                }
            }
            if (isRootView) {
                for (UIView *d in [toolbar subviews]) {
                    if (d.tag == 7 || d.tag == 11) {
                        [d setHidden:NO];
                    }
                }
            }else{
                for (UIView *d in [toolbar subviews]) {
                    if (d.tag == 7 || d.tag == 8 || d.tag == 12) {
                        [d setHidden:NO];
                    }
                }
            }
            [scrollView setHidden:YES];
            [scrollView setUserInteractionEnabled:NO];
            [keepLit setHidden:YES];
            [keepLitWhenServer setHidden:YES];
            [keepLitWhenPower setHidden:YES];
            [keepLitWhenPowerLabel setHidden:YES];
            [keepLitLabel setHidden:YES];
            [keepLitWhenServerLabel setHidden:YES];
            [bg setHidden:YES];
        }];
        
        sender.tag = 4;
    }
}

- (void)back{
    [pv1 dismiss];
    [pv dismiss];
    [videoPop dismiss];
    [rename dismiss];
    [musicPop dismiss];
    
    NSFileManager *manager = [NSFileManager defaultManager];
    NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
    [manager removeItemAtPath:[[d valueForKey:@"tmpCL3275OpxuJS8tDBW844SD.html"] stringByAppendingFormat:@"/tmpCL3275OpxuJS8tDBW844SD.html"] error:nil];

    
    if (isRootView) {
        return;
    }
    [UIView animateWithDuration:0.3 animations:^{
        for (UIView *view in [self.view subviews]) {
            if (view.tag == 626) {
                view.alpha = 0;
            }
            
        }
    } completion:^(BOOL finished){
        if ([self.paths count] == 1) {
            [backBtn setHidden:YES];
            [newbtn1 setHidden:YES];
            [addFile setHidden:YES];
            [newbtn setHidden:NO];
        }else{
            [self.paths removeLastObject];
            nowPath = [self.paths lastObject];
            if ([self.paths count] == 1) {
                [backBtn setHidden:YES];
                [newbtn1 setHidden:YES];
                [addFile setHidden:YES];
                [newbtn setHidden:NO];
                
                isRootView = YES;
            }else{
                isRootView = NO;
            }
            self.fileList = [HTMLData fileList:[self.paths lastObject]];
            [iPhoneTableView reloadData];
        }
        
        [UIView animateWithDuration:0.1 animations:^{
            for (UIView *view in [self.view subviews]) {
                if (view.tag == 626) {
                    view.alpha = 1;
                }
            }
        }];
    }];
    
}

- (void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
	[[UIApplication sharedApplication] beginReceivingRemoteControlEvents];
    [self scrollViewDidScroll:iPhoneTableView];
}

- (void)scrollViewDidScroll:(UIScrollView *)tableView {
    if (tableView.tag != 327) {
        if (tableView.tag == 888) {
            
        }else{
            CGRect frame = shadowViewTop.frame;
            frame.origin.y = tableView.frame.origin.y - tableView.contentOffset.y - shadowViewTop.frame.size.height;
            shadowViewTop.frame = frame;
            
        }
    }else{
        
        
    }

}

- (void)showtheimage:(HTMLButton *)tap{
    HTMLCell *cell = (HTMLCell *)[iPhoneTableView cellForRowAtIndexPath:tap.indexPath];
    selectCell = cell;
    theRow = tap.indexPath.row;
    if (cell.isFile == NO) {
        CGPoint point1;
        if (iPhone5) {
            point1 = cell.frame.origin;
            CGPoint off = [iPhoneTableView contentOffset];
            point1.y = point1.y - off.y + 30;
            
        }else{
            point1 = cell.frame.origin;
            CGPoint off = [iPhoneTableView contentOffset];
            point1.y = point1.y - off.y + 30;
            
        }
        if ([[HTMLData language]hasPrefix:@"zh"]) {
            rename = [PopoverView showPopoverAtPoint:point1 inView:self.view withTitle:cell.filename.text withStringArray:@[@"复制",@"移动",@"Dropbox"] delegate:self];
            [rename setTag:10032];
        }else{
            rename = [PopoverView showPopoverAtPoint:point1 inView:self.view withTitle:cell.filename.text withStringArray:@[@"Copy",@"Move",@"Dropbox"] delegate:self];
            [rename setTag:10032];
        }
        return;
    }

    CGPoint point1;
    if (iPhone5) {
        point1 = cell.frame.origin;
        CGPoint off = [iPhoneTableView contentOffset];
        point1.y = point1.y - off.y + 30;
        
    }else{
        point1 = cell.frame.origin;
        CGPoint off = [iPhoneTableView contentOffset];
        point1.y = point1.y - off.y + 30;
        
    }
    
    if ([[HTMLData language]hasPrefix:@"zh"]) {
        if ([HTMLData isEditableFile:cell.filePath]) {
            rename = [PopoverView showPopoverAtPoint:point1 inView:self.view withTitle:cell.filename.text withStringArray:@[@"编辑",@"重命名",@"复制",@"Move",@"Dropbox"] delegate:self];
            [rename setTag:777];
        }else{
            rename = [PopoverView showPopoverAtPoint:point1 inView:self.view withTitle:cell.filename.text withStringArray:@[@"重命名",@"复制",@"移动",@"Dropbox"] delegate:self];
            [rename setTag:666];
        }
    }else{
        if ([HTMLData isEditableFile:cell.filePath]) {
            rename = [PopoverView showPopoverAtPoint:point1 inView:self.view withTitle:cell.filename.text withStringArray:@[@"Edit",@"Rename",@"Copy",@"Move",@"Dropbox"] delegate:self];
            [rename setTag:777];
        }else{
            rename = [PopoverView showPopoverAtPoint:point1 inView:self.view withTitle:cell.filename.text withStringArray:@[@"Rename",@"Copy",@"Move",@"Dropbox"] delegate:self];
            [rename setTag:666];
        }
    }
    
    
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *CustomCellIdentifier = @"HTMLCell_iPad";
    
    static BOOL nibsRegistered = NO;
    if (!nibsRegistered) {
        UINib *nib = [UINib nibWithNibName:@"HTMLCell_iPad" bundle:nil];
        [tableView registerNib:nib forCellReuseIdentifier:CustomCellIdentifier];
        nibsRegistered = YES;
    }
    HTMLCell *cell = [tableView dequeueReusableCellWithIdentifier:CustomCellIdentifier];
    cell.filename.text = [fileList objectAtIndex:indexPath.row];
    NSString *path = [NSString stringWithFormat:@"%@/%@",nowPath,[fileList objectAtIndex:indexPath.row]];
    cell.isFile = ![HTMLData isDir:path];
    
    
    //mainHTML
    if (cell.isFile) {
        NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
        if ([cell.filename.text isEqualToString:[d valueForKey:nowPath]]) {
            cell.mainHTML.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"mainHTML" ofType:@"png"]];
        }else{
            cell.mainHTML.image = nil;
        }
    }else{
        cell.mainHTML.image = nil;
    }
    
    //icon
    if (cell.isFile) {
        cell.icon.image = [HTMLFileType filename:cell.filename.text];
        cell.filePath = [nowPath stringByAppendingFormat:@"/%@",[fileList objectAtIndex:indexPath.row]];
        HTMLButton *btn = [HTMLButton buttonWithType:UIButtonTypeCustom];
        [btn setBackgroundColor:[UIColor clearColor]];
        [btn setFrame:cell.icon.frame];
        [btn setIndexPath:indexPath];
        [btn addTarget:self action:@selector(showtheimage:) forControlEvents:UIControlEventTouchUpInside];
        [cell addSubview:btn];
    }else{
        
        cell.icon.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"folder" ofType:@"png"]];
        cell.folderPath = [nowPath stringByAppendingFormat:@"/%@",[fileList objectAtIndex:indexPath.row]];
        cell.filePath = @"";
        HTMLButton *btn = [HTMLButton buttonWithType:UIButtonTypeCustom];
        [btn setBackgroundColor:[UIColor clearColor]];
        [btn setFrame:cell.icon.frame];
        [btn setIndexPath:indexPath];
        [btn addTarget:self action:@selector(showtheimage:) forControlEvents:UIControlEventTouchUpInside];
        [cell addSubview:btn];
    }
    
    
    //bg
    UIView *o = [[UIView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, 64)];
    o.backgroundColor = [UIColor colorWithRed:0.9 green:0.876 blue:0.857 alpha:1];
    [cell setSelectedBackgroundView:o];
    [cell.filename setHighlightedTextColor:[UIColor blackColor]];
    
    if (cell.isFile) {
        NSDate *date = [[HTMLData fileInfo:cell.filePath] objectForKey:NSFileModificationDate];
        if (date) {
            NSCalendar *calender = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
            NSUInteger units = NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit|NSHourCalendarUnit|NSMinuteCalendarUnit|NSSecondCalendarUnit;
            NSDateComponents *components = [calender components:units fromDate:date];
            NSString *text;
            if ([components minute] < 10) {
                text = [NSString stringWithFormat:@"%d-%d-%d %d:0%d", [components year], [components month], [components day], [components hour], [components minute]];
            }else{
                text = [NSString stringWithFormat:@"%d-%d-%d %d:%d", [components year], [components month], [components day], [components hour], [components minute]];
            }
            cell.create.text = text;
            cell.large.text = [HTMLData changeToProper:[[[HTMLData fileInfo:cell.filePath] objectForKey:NSFileSize] unsignedLongLongValue]];
            ;
            
        }
    }else{
        NSDate *date = [[HTMLData fileInfo:cell.folderPath] objectForKey:NSFileModificationDate];
        if (date) {
            NSCalendar *calender = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
            NSUInteger units = NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit|NSHourCalendarUnit|NSMinuteCalendarUnit|NSSecondCalendarUnit;
            NSDateComponents *components = [calender components:units fromDate:date];
            NSString *text;
            if ([components minute] < 10) {
                text = [NSString stringWithFormat:@"%d-%d-%d %d:0%d", [components year], [components month], [components day], [components hour], [components minute]];
            }else{
                text = [NSString stringWithFormat:@"%d-%d-%d %d:%d", [components year], [components month], [components day], [components hour], [components minute]];
            }
            
            cell.create.text = text;
            cell.large.text = [HTMLData changeToProper:[HTMLData fileSizeForDir:cell.folderPath]];
            ;
            
        }
        
    }
	return cell;
}

-(void)configNowPlayingInfoCenter:(NSDictionary *)d{
    
    if (NSClassFromString(@"MPNowPlayingInfoCenter")) {
        
        NSMutableDictionary *dict = [[NSMutableDictionary alloc] init];
        [dict setObject:[d valueForKey:@"name"] forKey:MPMediaItemPropertyTitle];
        [dict setObject:[d valueForKey:@"singer"] forKey:MPMediaItemPropertyArtist];
        [dict setObject:[d valueForKey:@"album"] forKey:MPMediaItemPropertyAlbumTitle];
        
        UIImage *image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"icon" ofType:@"png"]];
        MPMediaItemArtwork *artwork = [[MPMediaItemArtwork alloc] initWithImage:image];
        [dict setObject:artwork forKey:MPMediaItemPropertyArtwork];
        
        [[MPNowPlayingInfoCenter defaultCenter] setNowPlayingInfo:dict];
        
    }
    
}


- (void)popoverView:(PopoverView *)popoverView didSelectItemAtIndex:(NSInteger)buttonIndex
{
    if (popoverView.tag == 777) {
        if (buttonIndex == 0) {
            //edit
            [popoverView dismiss];
            [self editCode:selectCell];
            return;
        }else if(buttonIndex == 1) {
            //rename
            [popoverView dismiss];
            if ([[HTMLData language]hasPrefix:@"zh"]) {
                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"重命名" message:@"\n\n" delegate:self cancelButtonTitle:@"取消" otherButtonTitles:@"确定", nil];
                needName = [[SLGlowingTextField alloc] initWithFrame:CGRectMake(25, 57, 232, 27)];
                if (IOS_VERSION > 6.2) {
                    [alert setAlertViewStyle:UIAlertViewStylePlainTextInput];
                }
                [alert addSubview:needName];
                [alert setTag:999];
                [needName becomeFirstResponder];
                [alert show];
            }else{
                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Rename" message:@"\n\n" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil];
                needName = [[SLGlowingTextField alloc] initWithFrame:CGRectMake(25, 57, 232, 27)];
                if (IOS_VERSION > 6.2) {
                    [alert setAlertViewStyle:UIAlertViewStylePlainTextInput];
                }
                [alert addSubview:needName];
                [alert setTag:999];
                [needName becomeFirstResponder];
                [alert show];
            }
        }else if (buttonIndex == 2){
            //Copy
            [popoverView dismiss];
            if ([selectCell.filePath isEqualToString:@""]) {
                itemToCopy = [NSString stringWithString:selectCell.filePath];
            }else{
                itemToCopy = [NSString stringWithString:[nowPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:theRow]]];
            }
            
            isCopy = YES;
            hasItemToDo = YES;
            itemToMove = nil;
        }else if (buttonIndex == 3){
            //Move
            [popoverView dismiss];
            if ([selectCell.filePath isEqualToString:@""]) {
                itemToMove = [NSString stringWithString:selectCell.filePath];
            }else{
                itemToMove = [NSString stringWithString:[nowPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:theRow]]];
            }
            isCopy = NO;
            hasItemToDo = YES;
            itemToCopy = nil;
        }else if (buttonIndex == 4){
            //dropbox
            [popoverView dismiss];
            if (![[DBSession sharedSession] isLinked]) {
                SIAlertView *alert;
                if ([[HTMLData language] hasPrefix:@"zh"]) {
                    alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"您要连接到Dropbox以便上传工程吗?"];
                    [alert addButtonWithTitle:@"是的" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
                        [[DBSession sharedSession] linkFromController:self];
                    }];
                    [alert addButtonWithTitle:@"不,谢谢" type:SIAlertViewButtonTypeCancel handler:^(SIAlertView *alertView){
                        
                    }];
                    [alert show];
                }else{
                    alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"Link To Dropbox?"];
                    [alert addButtonWithTitle:@"OK" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
                        [[DBSession sharedSession] linkFromController:self];
                    }];
                    [alert addButtonWithTitle:@"No" type:SIAlertViewButtonTypeCancel handler:^(SIAlertView *alertView){
                        
                    }];
                    [alert show];
                }
            }else{
                
                CGContextRef context = UIGraphicsGetCurrentContext();
                [UIView beginAnimations:@"animationID" context:context];
                [UIView setAnimationDuration:0.5f];
                [UIView setAnimationDelegate:self];
                self.uploadFile.alpha = 1.0;
                [UIView commitAnimations];
                
                if ([[HTMLData language] hasPrefix:@"zh"]) {
                    [SVProgressHUD showWithStatus:@"开始上传..." maskType:SVProgressHUDMaskTypeClear];
                }else{
                    [SVProgressHUD showWithStatus:@"Uploading..." maskType:SVProgressHUDMaskTypeClear];
                }
                
                
                NSDate *date = [NSDate date];
                NSCalendar *calender = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
                NSUInteger units = NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit|NSHourCalendarUnit|NSMinuteCalendarUnit|NSSecondCalendarUnit;
                NSDateComponents *components = [calender components:units fromDate:date];
                NSString *text;
                if ([components minute] < 10) {
                    text = [NSString stringWithFormat:@"%d-%d-%d %d:0%d", [components year], [components month], [components day], [components hour], [components minute]];
                }else{
                    text = [NSString stringWithFormat:@"%d-%d-%d %d:%d", [components year], [components month], [components day], [components hour], [components minute]];
                }
                
                [[self restClient] uploadFile:[NSString stringWithFormat:@"%@/%@ - %@",[[self.paths lastObject] lastPathComponent],text,selectCell.filename.text] toPath:@"/"
                                withParentRev:nil fromPath:[NSString stringWithFormat:@"%@",selectCell.filePath]];
                [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
            }
        }
    }else if(popoverView.tag == 666){
        if (buttonIndex  == 0) {
            //rename
            [popoverView dismiss];
            
            if ([[HTMLData language]hasPrefix:@"zh"]) {
                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"重命名" message:@"\n\n" delegate:self cancelButtonTitle:@"取消" otherButtonTitles:@"确定", nil];
                needName = [[SLGlowingTextField alloc] initWithFrame:CGRectMake(25, 57, 232, 27)];
                if (IOS_VERSION > 6.2) {
                    [alert setAlertViewStyle:UIAlertViewStylePlainTextInput];
                }
                [alert addSubview:needName];
                [alert setTag:999];
                [needName becomeFirstResponder];
                [alert show];
            }else {
                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Rename" message:@"\n\n" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil];
                needName = [[SLGlowingTextField alloc] initWithFrame:CGRectMake(25, 57, 232, 27)];
                if (IOS_VERSION > 6.2) {
                    [alert setAlertViewStyle:UIAlertViewStylePlainTextInput];
                }
                [alert addSubview:needName];
                [alert setTag:999];
                [needName becomeFirstResponder];
                [alert show];
            
            }
        }else if (buttonIndex == 1){
            //Copy
            if ([selectCell.filePath isEqualToString:@""]) {
                itemToCopy = [NSString stringWithString:selectCell.filePath];
            }else{
                itemToCopy = [NSString stringWithString:[nowPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:theRow]]];
            }
            isCopy = YES;
            hasItemToDo = YES;
            itemToMove = nil;
            [popoverView dismiss];
        }else if (buttonIndex == 2){
            //Move
            if ([selectCell.filePath isEqualToString:@""]) {
                itemToMove = [NSString stringWithString:selectCell.filePath];
            }else{
                itemToMove = [NSString stringWithString:[nowPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:theRow]]];
            }
            isCopy = NO;
            hasItemToDo = YES;
            itemToCopy = nil;
            [popoverView dismiss];
        }else if (buttonIndex == 3){
                //dropbox
                [popoverView dismiss];
                if (![[DBSession sharedSession] isLinked]) {
                    SIAlertView *alert;
                    if ([[HTMLData language] hasPrefix:@"zh"]) {
                        alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"您要连接到Dropbox以便上传工程吗?"];
                        [alert addButtonWithTitle:@"是的" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
                            [[DBSession sharedSession] linkFromController:self];
                        }];
                        [alert addButtonWithTitle:@"不,谢谢" type:SIAlertViewButtonTypeCancel handler:^(SIAlertView *alertView){
                            
                        }];
                        [alert show];
                    }else{
                        alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"Link To Dropbox?"];
                        [alert addButtonWithTitle:@"OK" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
                            [[DBSession sharedSession] linkFromController:self];
                        }];
                        [alert addButtonWithTitle:@"No" type:SIAlertViewButtonTypeCancel handler:^(SIAlertView *alertView){
                            
                        }];
                        [alert show];
                    }
                }else{
                    
                    CGContextRef context = UIGraphicsGetCurrentContext();
                    [UIView beginAnimations:@"animationID" context:context];
                    [UIView setAnimationDuration:0.5f];
                    [UIView setAnimationDelegate:self];
                    self.uploadFile.alpha = 1.0;
                    [UIView commitAnimations];
                    if ([[HTMLData language] hasPrefix:@"zh"]) {
                        [SVProgressHUD showWithStatus:@"开始上传..." maskType:SVProgressHUDMaskTypeClear];
                    }else{
                        [SVProgressHUD showWithStatus:@"Uploading..." maskType:SVProgressHUDMaskTypeClear];
                    }
                    
                    
                    NSDate *date = [NSDate date];
                    NSCalendar *calender = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
                    NSUInteger units = NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit|NSHourCalendarUnit|NSMinuteCalendarUnit|NSSecondCalendarUnit;
                    NSDateComponents *components = [calender components:units fromDate:date];
                    NSString *text;
                    if ([components minute] < 10) {
                        text = [NSString stringWithFormat:@"%d-%d-%d %d:0%d", [components year], [components month], [components day], [components hour], [components minute]];
                    }else{
                        text = [NSString stringWithFormat:@"%d-%d-%d %d:%d", [components year], [components month], [components day], [components hour], [components minute]];
                    }
                    
                    [[self restClient] uploadFile:[NSString stringWithFormat:@"%@/%@ - %@",[[self.paths lastObject] lastPathComponent],text,selectCell.filename.text] toPath:@"/"
                                    withParentRev:nil fromPath:[NSString stringWithFormat:@"%@",selectCell.filePath]];
                    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
                }
        }
    }else if (popoverView.tag == 888) {
        return;
    }else if (popoverView.tag == 10032){
        [popoverView dismiss];
        if (buttonIndex == 0){
            //Copy
            itemToCopy = [NSString stringWithString:[nowPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:theRow]]];
            isCopy = YES;
            itemToMove = nil;
            hasItemToDo = YES;
        }else if (buttonIndex == 1){
            //Move
            itemToMove = [NSString stringWithString:[nowPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:theRow]]];
            isCopy = NO;
            itemToCopy = nil;
            hasItemToDo = YES;
        }else if (buttonIndex == 2){
            if (![[DBSession sharedSession] isLinked]) {
                SIAlertView *alert;
                if ([[HTMLData language] hasPrefix:@"zh"]) {
                    alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"您要连接到Dropbox以便上传工程吗?"];
                    [alert addButtonWithTitle:@"是的" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
                        [[DBSession sharedSession] linkFromController:self];
                    }];
                    [alert addButtonWithTitle:@"不,谢谢" type:SIAlertViewButtonTypeCancel handler:^(SIAlertView *alertView){
                        
                    }];
                    [alert show];
                }else{
                    alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"Link To Dropbox?"];
                    [alert addButtonWithTitle:@"OK" type:SIAlertViewButtonTypeDefault handler:^(SIAlertView *alertView){
                        [[DBSession sharedSession] linkFromController:self];
                    }];
                    [alert addButtonWithTitle:@"No" type:SIAlertViewButtonTypeCancel handler:^(SIAlertView *alertView){
                        
                    }];
                    [alert show];
                }
            }else{
                
                
                //show HUD zipping
                
                if ([[self WiFiIPAddress] length] < 4) {
                    SIAlertView *alert;
                    if ([[HTMLData language] hasPrefix:@"zh"]) {
                        alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"您当前可能处于运营商网络中，上传文件将使用运营商流量，您确定要继续吗?"];
                        [alert addButtonWithTitle:@"是的" type:SIAlertViewButtonTypeCancel handler:^(SIAlertView *alertView){
                            [SVProgressHUD showWithStatus:@"正在压缩文件..." maskType:SVProgressHUDMaskTypeClear];
                            [NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(startZip) userInfo:nil repeats:NO];
                            /*
                            ZipFile *zipFile = [[ZipFile alloc] initWithFileName:[NSString stringWithFormat:@"%@/%@.zip",docPath,selectCell.filename.text] mode:ZipFileModeCreate];
                            // 读取目录中的文件
                            NSError *error = nil;
                            NSArray *files = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:selectCell.folderPath error:&error];   // 将每个文件写入zip
                            for (NSString *filename in files) {
                                // 获取文件创建日期
                                NSString *path = [selectCell.folderPath stringByAppendingPathComponent:filename];
                                NSDictionary *attributes = [[NSFileManager defaultManager] attributesOfItemAtPath:path error:&error];
                                NSDate *date = [attributes objectForKey:NSFileCreationDate];
                                // 写文件
                                ZipWriteStream *stream = [zipFile writeFileInZipWithName:filename fileDate:date compressionLevel:ZipCompressionLevelBest];
                                NSData *data = [NSData dataWithContentsOfFile:path];
                                [stream writeZipData:data];
                                [stream finishedWriting];
                            }
                            // 关闭zip文件
                            [zipFile close];
                            if ([[HTMLData language] hasPrefix:@"zh"]) {
                                [SVProgressHUD showSuccessWithStatus:@"压缩文件完成" duration:0.7];
                            }else{
                                [SVProgressHUD showSuccessWithStatus:@"Compressing files, done!" duration:0.7];
                            }*/

                            [zip CreateZipFile2:[NSString stringWithFormat:@"%@/%@.zip",docPath,selectCell.filename.text]];
                            NSError *error = nil;
                            NSArray *files = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:selectCell.folderPath error:&error];
                            BOOL isDir = NO;
                            NSFileManager *manager = [NSFileManager defaultManager];
                            sourceFolderPathLength = [selectCell.folderPath length];
                            for (NSString *name in files) {
                                [manager fileExistsAtPath:[selectCell.folderPath stringByAppendingFormat:@"/%@",name] isDirectory:&isDir];
                                if (isDir) {
                                    [self addFolderFilesIntoZipNewPath:[selectCell.folderPath stringByAppendingFormat:@"/%@",name] times:0 oldPath:selectCell.folderPath];
                                }else{
                                    [zip addFileToZip:[selectCell.folderPath stringByAppendingFormat:@"/%@",name] newname:name];
                                }
                            }
                            
                            if ([[HTMLData language] hasPrefix:@"zh"]) {
                                [SVProgressHUD showSuccessWithStatus:@"压缩文件完成" duration:0.7];
                            }else{
                                [SVProgressHUD showSuccessWithStatus:@"Compressing files, done!" duration:0.7];
                            }
                            [zip CloseZipFile2];
                            [self startUpload];
                            
                        }];
                        [alert addButtonWithTitle:@"取消" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView){
                            
                        }];
                        [alert show];
                    }else{
                        alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"You are not joining any WiFi network, sure to continue?"];
                        [alert addButtonWithTitle:@"Yes" type:SIAlertViewButtonTypeCancel handler:^(SIAlertView *alertView){
                            [SVProgressHUD showWithStatus:@"Compressing files..." maskType:SVProgressHUDMaskTypeClear];
                            [NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(startZip) userInfo:nil repeats:NO];
                            /*
                            ZipFile *zipFile = [[ZipFile alloc] initWithFileName:[NSString stringWithFormat:@"%@/%@.zip",docPath,selectCell.filename.text] mode:ZipFileModeCreate];
                            // 读取目录中的文件
                            NSError *error = nil;
                            NSArray *files = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:selectCell.folderPath error:&error];   // 将每个文件写入zip
                            for (NSString *filename in files) {
                                // 获取文件创建日期
                                NSString *path = [selectCell.folderPath stringByAppendingPathComponent:filename];
                                NSDictionary *attributes = [[NSFileManager defaultManager] attributesOfItemAtPath:path error:&error];
                                NSDate *date = [attributes objectForKey:NSFileCreationDate];
                                // 写文件
                                ZipWriteStream *stream = [zipFile writeFileInZipWithName:filename fileDate:date compressionLevel:ZipCompressionLevelBest];
                                NSData *data = [NSData dataWithContentsOfFile:path];
                                [stream writeZipData:data];
                                [stream finishedWriting];
                            }
                            // 关闭zip文件
                            [zipFile close];
                            if ([[HTMLData language] hasPrefix:@"zh"]) {
                                [SVProgressHUD showSuccessWithStatus:@"压缩文件完成" duration:0.7];
                            }else{
                                [SVProgressHUD showSuccessWithStatus:@"Compressing files, done!" duration:0.7];
                            }*/

                                                        
                        }];
                        [alert addButtonWithTitle:@"Cancel" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView){
                            
                        }];
                        [alert show];
                    }
                }else{
                    [SVProgressHUD showWithStatus:@"正在压缩文件..." maskType:SVProgressHUDMaskTypeClear];
                    [NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(startZip) userInfo:nil repeats:NO];
                    /*
                    ZipFile *zipFile = [[ZipFile alloc] initWithFileName:[NSString stringWithFormat:@"%@/%@.zip",docPath,selectCell.filename.text] mode:ZipFileModeCreate];
                    // 读取目录中的文件
                    NSError *error = nil;
                    NSArray *files = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:selectCell.folderPath error:&error];   // 将每个文件写入zip
                    for (NSString *filename in files) {
                        // 获取文件创建日期
                        NSString *path = [selectCell.folderPath stringByAppendingPathComponent:filename];
                        NSDictionary *attributes = [[NSFileManager defaultManager] attributesOfItemAtPath:path error:&error];
                        NSDate *date = [attributes objectForKey:NSFileCreationDate];
                        // 写文件
                        ZipWriteStream *stream = [zipFile writeFileInZipWithName:filename fileDate:date compressionLevel:ZipCompressionLevelBest];
                        NSData *data = [NSData dataWithContentsOfFile:path];
                        [stream writeZipData:data];
                        [stream finishedWriting];
                    }
                    // 关闭zip文件
                    [zipFile close];
                    if ([[HTMLData language] hasPrefix:@"zh"]) {
                        [SVProgressHUD showSuccessWithStatus:@"压缩文件完成" duration:0.7];
                    }else{
                        [SVProgressHUD showSuccessWithStatus:@"Compressing files, done!" duration:0.7];
                    }*/

                    [zip CreateZipFile2:[NSString stringWithFormat:@"%@/%@.zip",docPath,selectCell.filename.text]];
                    NSError *error = nil;
                    NSArray *files = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:selectCell.folderPath error:&error];
                    BOOL isDir = NO;
                    NSFileManager *manager = [NSFileManager defaultManager];
                    sourceFolderPathLength = [selectCell.folderPath length];
                    for (NSString *name in files) {
                        [manager fileExistsAtPath:[selectCell.folderPath stringByAppendingFormat:@"/%@",name] isDirectory:&isDir];
                        if (isDir) {
                            [self addFolderFilesIntoZipNewPath:[selectCell.folderPath stringByAppendingFormat:@"/%@",name] times:0 oldPath:selectCell.folderPath];
                        }else{
                            [zip addFileToZip:[selectCell.folderPath stringByAppendingFormat:@"/%@",name] newname:name];
                        }
                    }
                    
                    if ([[HTMLData language] hasPrefix:@"zh"]) {
                        [SVProgressHUD showSuccessWithStatus:@"压缩文件完成" duration:0.7];
                    }else{
                        [SVProgressHUD showSuccessWithStatus:@"Compressing files, done!" duration:0.7];
                    }
                    [zip CloseZipFile2];
                    [self startUpload];
                }
                
            }
        }
        //
        
        return;
        
    }//zip end

    
    if (popoverView == pv) {
        [popoverView performSelector:@selector(dismiss) withObject:nil afterDelay:0.1f];
        if (pv.tag == 10010) {
            if (hasItemToDo) {
                if (buttonIndex == 0) {
                    [self takePhotoOrShotVideo];
                }else if (buttonIndex == 1) {
                    [self pickFromLibrary];
                }else if(buttonIndex == 2) {
                    NSFileManager *manager = [NSFileManager defaultManager];
                    NSError *error = nil;
                    if (isCopy) {
                        [manager copyItemAtPath:itemToCopy toPath:[[self.paths lastObject] stringByAppendingFormat:@"/%@",[itemToCopy lastPathComponent]] error:&error];
                    }else{
                        [manager moveItemAtPath:itemToMove toPath:[[self.paths lastObject] stringByAppendingFormat:@"/%@",[itemToMove lastPathComponent]] error:&error];
                    }
                    hasItemToDo = NO;
                    itemToMove = nil;
                    itemToCopy = nil;
                    if (error == nil) {
                        [NSTimer scheduledTimerWithTimeInterval:0.3 target:self selector:@selector(updateTable) userInfo:nil repeats:NO];
                    }
                }else if(buttonIndex == 3) {
                    //Cancel
                }
                
            }else{
                if (buttonIndex == 0) {
                    [self takePhotoOrShotVideo];
                }else if (buttonIndex == 1) {
                    [self pickFromLibrary];
                }else if(buttonIndex == 2) {
                    
                }else if(buttonIndex == 3) {
                    //Cancel
                }
                
            }
        }else if (pv.tag == 10086){
            [pv dismiss];
            if (hasItemToDo) {
                if (buttonIndex == 0) {
                    //Photo Library
                    UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
                    
                    [imagePicker setSourceType:UIImagePickerControllerSourceTypePhotoLibrary];
                    [imagePicker setDelegate:self];
                    NSArray *temp_MediaTypes = [UIImagePickerController availableMediaTypesForSourceType:imagePicker.sourceType];
                    imagePicker.mediaTypes = temp_MediaTypes;
                    NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
                    if ([d valueForKey:@"videoQuality"] == NULL) {
                        imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
                    }else if ([[d valueForKey:@"videoQuality"] boolValue]) {
                        imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
                    }else{
                        imagePicker.videoQuality = UIImagePickerControllerQualityTypeIFrame1280x720;
                    }
                    
                    
                    UIPopoverController *popover = [[UIPopoverController alloc] initWithContentViewController:imagePicker];
                    self.popoverController = popover;
                    [popoverController presentPopoverFromRect:CGRectMake(80, 707, 300, 300) inView:self.view permittedArrowDirections:UIPopoverArrowDirectionDown animated:YES];
                }else if (buttonIndex == 1) {
                    NSFileManager *manager = [NSFileManager defaultManager];
                    NSError *error = nil;
                    if (isCopy) {
                        [manager copyItemAtPath:itemToCopy toPath:[[self.paths lastObject] stringByAppendingFormat:@"/%@",[itemToCopy lastPathComponent]] error:&error];
                    }else{
                        [manager moveItemAtPath:itemToMove toPath:[[self.paths lastObject] stringByAppendingFormat:@"/%@",[itemToMove lastPathComponent]] error:&error];
                    }
                    hasItemToDo = NO;
                    itemToMove = nil;
                    itemToCopy = nil;
                    if (error == nil) {
                        [NSTimer scheduledTimerWithTimeInterval:0.3 target:self selector:@selector(updateTable) userInfo:nil repeats:NO];
                    }
                }else if(buttonIndex == 2) {
                
                }

            }else{
                //No Item
                UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
                
                [imagePicker setSourceType:UIImagePickerControllerSourceTypePhotoLibrary];
                [imagePicker setDelegate:self];
                NSArray *temp_MediaTypes = [UIImagePickerController availableMediaTypesForSourceType:imagePicker.sourceType];
                imagePicker.mediaTypes = temp_MediaTypes;
                NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
                if ([d valueForKey:@"videoQuality"] == NULL) {
                    imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
                }else if ([[d valueForKey:@"videoQuality"] boolValue]) {
                    imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
                }else{
                    imagePicker.videoQuality = UIImagePickerControllerQualityTypeIFrame1280x720;
                }
                
                
                UIPopoverController *popover = [[UIPopoverController alloc] initWithContentViewController:imagePicker];
                self.popoverController = popover;
                [popoverController presentPopoverFromRect:CGRectMake(80, 707, 300, 300) inView:self.view permittedArrowDirections:UIPopoverArrowDirectionDown animated:YES];
            }
        }
    }
        
    // Figure out which string was selected, store in "string"
    
    // Show a success image, with the string from the array
    
    // alternatively, you can use
    // [popoverView showSuccess];
    // or
    // [popoverView showError];
    
    // Dismiss the PopoverView after 0.5 seconds
    
}

- (void)startZip{
    [zip CreateZipFile2:[NSString stringWithFormat:@"%@/%@.zip",docPath,selectCell.filename.text]];
    NSError *error = nil;
    NSArray *files = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:selectCell.folderPath error:&error];
    BOOL isDir = NO;
    NSFileManager *manager = [NSFileManager defaultManager];
    sourceFolderPathLength = [selectCell.folderPath length];
    for (NSString *name in files) {
        [manager fileExistsAtPath:[selectCell.folderPath stringByAppendingFormat:@"/%@",name] isDirectory:&isDir];
        if (isDir) {
            [self addFolderFilesIntoZipNewPath:[selectCell.folderPath stringByAppendingFormat:@"/%@",name] times:0 oldPath:selectCell.folderPath];
        }else{
            [zip addFileToZip:[selectCell.folderPath stringByAppendingFormat:@"/%@",name] newname:name];
        }
    }
    
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        [SVProgressHUD showSuccessWithStatus:@"压缩文件完成" duration:0.7];
    }else{
        [SVProgressHUD showSuccessWithStatus:@"Compressing files, done!" duration:0.7];
    }
    [zip CloseZipFile2];
    [self startUpload];

}

- (void)addFolderFilesIntoZipNewPath:(NSString *)path times:(NSInteger)sub oldPath:(NSString *)oldpath1{
    NSError *error = nil;
    NSInteger length = [oldpath1 length] + 1;
    NSArray *files = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:path error:&error];
    BOOL isDir = NO;
    NSFileManager *manager = [NSFileManager defaultManager];
    for (NSString *name in files) {
        [manager fileExistsAtPath:[path stringByAppendingFormat:@"/%@",name] isDirectory:&isDir];
        if (isDir) {
            [self addFolderFilesIntoZipNewPath:[path stringByAppendingFormat:@"/%@",name] times:sub+1 oldPath:path];
        }else{
            if (sub == 0) {
                [zip addFileToZip:[path stringByAppendingFormat:@"/%@",name] newname:[[path substringFromIndex:length] stringByAppendingFormat:@"/%@",name]];
                
            }else{
                [zip addFileToZip:[path stringByAppendingFormat:@"/%@",name] newname:[[path substringFromIndex:sourceFolderPathLength] stringByAppendingFormat:@"/%@",name]];
            }
            
            
            
        }
    }
    
    
}

- (void)startUpload{
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    [UIView beginAnimations:@"animationID" context:context];
    [UIView setAnimationDuration:0.5f];
    [UIView setAnimationDelegate:self];
    self.uploadFile.alpha = 1.0;
    [UIView commitAnimations];
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        [SVProgressHUD showWithStatus:@"开始上传..." maskType:SVProgressHUDMaskTypeClear];
    }else{
        [SVProgressHUD showWithStatus:@"Uploading..." maskType:SVProgressHUDMaskTypeClear];
    }
    
    NSDate *date = [NSDate date];
    NSCalendar *calender = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSUInteger units = NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit|NSHourCalendarUnit|NSMinuteCalendarUnit|NSSecondCalendarUnit;
    NSDateComponents *components = [calender components:units fromDate:date];
    NSString *text;
    if ([components minute] < 10) {
        text = [NSString stringWithFormat:@"%d-%d-%d %d:0%d", [components year], [components month], [components day], [components hour], [components minute]];
    }else{
        text = [NSString stringWithFormat:@"%d-%d-%d %d:%d", [components year], [components month], [components day], [components hour], [components minute]];
    }

    
    [[self restClient] uploadFile:[NSString stringWithFormat:@"%@ - %@.zip",selectCell.filename.text,text] toPath:@"/"
                    withParentRev:nil fromPath:[NSString stringWithFormat:@"%@/%@.zip",docPath,selectCell.filename.text]];
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
}

- (void)restClient:(DBRestClient*)client uploadedFile:(NSString*)destPath
              from:(NSString*)srcPath metadata:(DBMetadata*)metadata {
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        [SVProgressHUD dismissWithSuccess:@"上传成功!"];
    }else{
        [SVProgressHUD dismissWithSuccess:@"Uploading Done!"];
    }
    
    
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    [UIView beginAnimations:@"animationID" context:context];
    [UIView setAnimationDuration:0.5f];
    [UIView setAnimationDelegate:self];
    self.uploadFile.alpha = 0.0;
    [UIView commitAnimations];
    
    [self.uploadFile setProgress:0.0 animated:NO];
    
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
    [self cleanZipFile];
}

- (void)restClient:(DBRestClient*)client uploadFileFailedWithError:(NSError*)error {
    [SVProgressHUD dismiss];
    
    CGContextRef context = UIGraphicsGetCurrentContext();
    [UIView beginAnimations:@"animationID" context:context];
    [UIView setAnimationDuration:0.5f];
    [UIView setAnimationDelegate:self];
    self.uploadFile.alpha = 0.0;
    [UIView commitAnimations];
    
    [self.uploadFile setProgress:0.0 animated:NO];
    
    SIAlertView *alert;
    [[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"很抱歉给您带来不便，但我们在上传时与服务器的链接发生了错误，请稍候再尝试"];
        [alert addButtonWithTitle:@"好的" type:SIAlertViewButtonTypeDefault handler:nil];
        [alert show];
    }else{
        alert = [[SIAlertView alloc] initWithTitle:@"Warning" andMessage:@"We are sorry about this, but we did meet some problem while uploading. Plase try again later."];
        [alert addButtonWithTitle:@"OK" type:SIAlertViewButtonTypeDefault handler:nil];
        [alert show];
    }
    [self cleanZipFile];
    //show HUD failed
}

- (void)cleanZipFile{
    NSFileManager *manager = [NSFileManager defaultManager];
    [manager removeItemAtPath:[NSString stringWithFormat:@"%@/%@.zip",docPath,selectCell.filename.text] error:nil];
    [self updateTable];
}

- (DBRestClient *)restClient {
    if (!restClient) {
        restClient =
        [[DBRestClient alloc] initWithSession:[DBSession sharedSession]];
        restClient.delegate = self;
    }
    return restClient;
}


- (void)remoteControlReceivedWithEvent: (UIEvent *)receivedEvent {
    if (isFLAC == YES) {
        switch (receivedEvent.subtype) {
            case 101:
                if (self.FLACplayer.currentState == ORGMEngineStatePlaying) {
                    
                    [self.FLACplayer pause];
                    [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPlay" ofType:@"png"]] forState:UIControlStateNormal];
                }else{
                    
                    [self.FLACplayer resume];
                    [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPause" ofType:@"png"]] forState:UIControlStateNormal];
                }
                
                break;
            case 100:
                if (self.FLACplayer.currentState == ORGMEngineStatePlaying) {
                    
                    [self.FLACplayer pause];
                    [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPlay" ofType:@"png"]] forState:UIControlStateNormal];
                }else{
                    
                    [self.FLACplayer resume];
                    [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPause" ofType:@"png"]] forState:UIControlStateNormal];
                }
                break;
            case UIEventSubtypeRemoteControlNextTrack:
                [self fastforwardBtn:nil];
                
                break;
            case UIEventSubtypeRemoteControlPreviousTrack:
                [self rewindBtn:nil];
                break;
            default:
                break;
        }
        
    }else{
        if (receivedEvent.type == UIEventTypeRemoteControl) {
            switch (receivedEvent.subtype) {
                case UIEventSubtypeRemoteControlTogglePlayPause:
                    if ([audioPlayer isPlaying]) {
                        [audioPlayer pause];
                        [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPlay" ofType:@"png"]] forState:UIControlStateNormal];
                    }else{
                        [audioPlayer play];
                        [play setImage:[UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"AudioPlayerPause" ofType:@"png"]] forState:UIControlStateNormal];
                    }
                    
                    break;
                case UIEventSubtypeRemoteControlNextTrack:
                    [self fastforwardBtn:nil];
                    
                    break;
                case UIEventSubtypeRemoteControlPreviousTrack:
                    [self rewindBtn:nil];
                    break;
                default:
                    break;
            }
        }
        
    }
}

- (void)popoverViewDidDismiss:(PopoverView *)popoverView
{
    if (popoverView == videoPop) {
        [moviePlayer pause];
        [moviePlayer stop];
        [moviePlayer setContentURL:nil];
    }else if(popoverView == pv){
        NSFileManager *manager = [NSFileManager defaultManager];
        [manager removeItemAtPath:[[self.paths lastObject] stringByAppendingFormat:@"/tmpCL3275OpxuJS8tDBW844SD.html"] error:nil];
        [self updateTable];
    }else if (popoverView == musicPop){
        if (isFLAC) {
            [self.FLACplayer stop];
            [audioPlayer stop];
        }else{
            [audioPlayer stop];
        }
        [updateDur invalidate];
        [self.panel setProgress:0.0];
    }
}


//ADDmark
- (void)addFileBtn{
    if ([[HTMLData language]hasPrefix:@"zh"]) {
        if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
            if (hasItemToDo) {
                pv = [PopoverView showPopoverAtPoint:point
                                              inView:self.view
                                           withTitle:@"添加文件"
                                     withStringArray:@[@"拍照或录像", @"从相册选择",@"粘贴",@"取消"]
                                            delegate:self];
                pv.tag = 10010;
            }else{
                pv = [PopoverView showPopoverAtPoint:point
                                              inView:self.view
                                           withTitle:@"添加文件"
                                     withStringArray:@[@"拍照或录像", @"从相册选择",@"取消"]
                                            delegate:self];
            }

        }else{
            UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
            
            [imagePicker setSourceType:UIImagePickerControllerSourceTypePhotoLibrary];
            [imagePicker setDelegate:self];
            NSArray *temp_MediaTypes = [UIImagePickerController availableMediaTypesForSourceType:imagePicker.sourceType];
            imagePicker.mediaTypes = temp_MediaTypes;
            NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
            if ([d valueForKey:@"videoQuality"] == NULL) {
                imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
            }else if ([[d valueForKey:@"videoQuality"] boolValue]) {
                imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
            }else{
                imagePicker.videoQuality = UIImagePickerControllerQualityTypeIFrame1280x720;
            }
            
            
            UIPopoverController *popover = [[UIPopoverController alloc] initWithContentViewController:imagePicker];
            self.popoverController = popover;
            [popoverController presentPopoverFromRect:CGRectMake(80, 707, 300, 300) inView:self.view permittedArrowDirections:UIPopoverArrowDirectionDown animated:YES];
            
            
        }
        
    }else{
        if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
            if (hasItemToDo) {
                pv = [PopoverView showPopoverAtPoint:point
                                              inView:self.view
                                           withTitle:@"Add file"
                                     withStringArray:@[@"Camera", @"Photo Library",@"Paste",@"Cancel"]
                                            delegate:self];
                pv.tag = 10010;
            }else{
                pv = [PopoverView showPopoverAtPoint:point
                                              inView:self.view
                                           withTitle:@"Add file"
                                     withStringArray:@[@"Camera", @"Photo Library",@"Cancel"]
                                            delegate:self];
            }
        }else{
            if (hasItemToDo) {
                pv = [PopoverView showPopoverAtPoint:point
                                              inView:self.view
                                           withTitle:@"Add file"
                                     withStringArray:@[@"Photo Library",@"Paste"]
                                            delegate:self];
                pv.tag = 10086;
            }else{
                UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
                
                [imagePicker setSourceType:UIImagePickerControllerSourceTypePhotoLibrary];
                [imagePicker setDelegate:self];
                NSArray *temp_MediaTypes = [UIImagePickerController availableMediaTypesForSourceType:imagePicker.sourceType];
                imagePicker.mediaTypes = temp_MediaTypes;
                NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
                if ([d valueForKey:@"videoQuality"] == NULL) {
                    imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
                }else if ([[d valueForKey:@"videoQuality"] boolValue]) {
                    imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
                }else{
                    imagePicker.videoQuality = UIImagePickerControllerQualityTypeIFrame1280x720;
                }
                UIPopoverController *popover = [[UIPopoverController alloc] initWithContentViewController:imagePicker];
                self.popoverController = popover;
                [popoverController presentPopoverFromRect:CGRectMake(80, 707, 300, 300) inView:self.view permittedArrowDirections:UIPopoverArrowDirectionDown animated:YES];
            }
        }
        
    }
    
}

- (void)takePhotoOrShotVideo{
    UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
    
    [imagePicker setSourceType:UIImagePickerControllerSourceTypeCamera];
    [imagePicker setDelegate:self];
    NSArray *temp_MediaTypes = [UIImagePickerController availableMediaTypesForSourceType:imagePicker.sourceType];
    imagePicker.mediaTypes = temp_MediaTypes;
    
    
    NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
    if ([d valueForKey:@"videoQuality"] == NULL) {
        imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
    }else if ([[d valueForKey:@"videoQuality"] boolValue]) {
        imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
    }else{
        imagePicker.videoQuality = UIImagePickerControllerQualityTypeIFrame1280x720;
    }
    
    
    [self presentViewController:imagePicker animated:YES completion:nil];
}

- (void)pickFromLibrary{
    UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
    
    [imagePicker setSourceType:UIImagePickerControllerSourceTypePhotoLibrary];
    [imagePicker setDelegate:self];
    NSArray *temp_MediaTypes = [UIImagePickerController availableMediaTypesForSourceType:imagePicker.sourceType];
    imagePicker.mediaTypes = temp_MediaTypes;
    NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
    if ([d valueForKey:@"videoQuality"] == NULL) {
        imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
    }else if ([[d valueForKey:@"videoQuality"] boolValue]) {
        imagePicker.videoQuality = UIImagePickerControllerQualityTypeHigh;
    }else{
        imagePicker.videoQuality = UIImagePickerControllerQualityTypeIFrame1280x720;
    }
    UIPopoverController *popover = [[UIPopoverController alloc] initWithContentViewController:imagePicker];
    self.popoverController = popover;
    [popoverController presentPopoverFromRect:CGRectMake(80, 707, 300, 300) inView:self.view permittedArrowDirections:UIPopoverArrowDirectionDown animated:YES];
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info
{
    
    NSString *mediaType = [info objectForKey:UIImagePickerControllerMediaType];
    
    
    if ([mediaType isEqualToString:@"public.image"]){
        NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
        
        UIImage *image = [info objectForKey:@"UIImagePickerControllerOriginalImage"];
        
        NSDate *date = [NSDate date];
        
        NSCalendar *calender = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSUInteger units = NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit|NSHourCalendarUnit|NSMinuteCalendarUnit|NSSecondCalendarUnit;
        NSDateComponents *components = [calender components:units fromDate:date];
        NSString *text;
        if ([components minute] < 10 || [components hour] < 10 || [components day] < 10 || [components month] < 10 || [components second] < 10) {
            text = [NSString stringWithFormat:@"%d%@%@%@%@%@", [components year], [components month] < 10 ? [NSString stringWithFormat:@"0%d",[components month]]:[NSString stringWithFormat:@"%d",[components month]], [components day] < 10 ? [NSString stringWithFormat:@"0%d",[components day]]:[NSString stringWithFormat:@"%d",[components day]], [components hour] < 10 ? [NSString stringWithFormat:@"0%d",[components hour]]:[NSString stringWithFormat:@"%d",[components hour]], [components minute] < 10 ? [NSString stringWithFormat:@"0%d",[components minute]]:[NSString stringWithFormat:@"%d",[components minute]],[components second] < 10 ? [NSString stringWithFormat:@"0%d",[components second]]:[NSString stringWithFormat:@"%d",[components second]]];
        }else{
            text = [NSString stringWithFormat:@"%d%d%d%d%d", [components year], [components month], [components day], [components hour], [components minute]];
        }
        if ([d valueForKey:@"photoType"] == NULL) {
            NSString *imageFile = [[self.paths lastObject] stringByAppendingPathComponent:[NSString stringWithFormat:@"/%@.jpg",text]];
            [UIImageJPEGRepresentation(image, 1.0f) writeToFile:imageFile atomically:YES];
        }else if ([[d valueForKey:@"photoType"] boolValue]){
            
            //mark name
            NSString *imageFile = [[self.paths lastObject] stringByAppendingPathComponent:[NSString stringWithFormat:@"/%@.jpg",text]];
            [UIImageJPEGRepresentation(image, 1.0f) writeToFile:imageFile atomically:YES];
        }else{
            NSString *imageFile = [[self.paths lastObject] stringByAppendingPathComponent:[NSString stringWithFormat:@"/%@.png",text]];
            [UIImagePNGRepresentation(image) writeToFile:imageFile atomically:YES];
        }
        
    }else if([mediaType isEqualToString:@"public.movie"]){
        NSURL *videoURL = [info objectForKey:UIImagePickerControllerMediaURL];
        NSData *videoData = [NSData dataWithContentsOfURL:videoURL];
        
        NSDate *date = [NSDate date];
        
        NSCalendar *calender = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
        NSUInteger units = NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit|NSHourCalendarUnit|NSMinuteCalendarUnit|NSSecondCalendarUnit;
        NSDateComponents *components = [calender components:units fromDate:date];
        NSString *text;
        if ([components minute] < 10 || [components hour] < 10 || [components day] < 10 || [components month] < 10 || [components second] < 10) {
            text = [NSString stringWithFormat:@"%d%@%@%@%@%@", [components year], [components month] < 10 ? [NSString stringWithFormat:@"0%d",[components month]]:[NSString stringWithFormat:@"%d",[components month]], [components day] < 10 ? [NSString stringWithFormat:@"0%d",[components day]]:[NSString stringWithFormat:@"%d",[components day]], [components hour] < 10 ? [NSString stringWithFormat:@"0%d",[components hour]]:[NSString stringWithFormat:@"%d",[components hour]], [components minute] < 10 ? [NSString stringWithFormat:@"0%d",[components minute]]:[NSString stringWithFormat:@"%d",[components minute]],[components second] < 10 ? [NSString stringWithFormat:@"0%d",[components second]]:[NSString stringWithFormat:@"%d",[components second]]];
        }else{
            text = [NSString stringWithFormat:@"%d%d%d%d%d", [components year], [components month], [components day], [components hour], [components minute]];
        }
        
        
        
        NSString *videoFile = [[self.paths lastObject] stringByAppendingPathComponent:[NSString stringWithFormat:@"/%@.mov",text]];
        [videoData writeToFile:videoFile atomically:YES];
    }

    [picker dismissViewControllerAnimated:YES completion:nil];
    
    [self updateTable];
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker {
    
    [picker dismissViewControllerAnimated:YES completion:nil];
    
}

- (void)updateTable{
    NSFileManager *manager = [NSFileManager defaultManager];
    NSUserDefaults *d = [NSUserDefaults standardUserDefaults];
    [manager removeItemAtPath:[[d valueForKey:@"tmpCL3275OpxuJS8tDBW844SD.html"] stringByAppendingFormat:@"/tmpCL3275OpxuJS8tDBW844SD.html"] error:nil];

    self.fileList = [HTMLData fileList:[self.paths lastObject]];
    [iPhoneTableView reloadData];
}


- (void)showTool:(BOOL)show backPath:(NSString *)path{
    if (backBtn.isHidden) {
        if (show) {
            [UIView animateWithDuration:0.3 animations:^{
                [backBtn setHidden:NO];
                [newbtn1 setHidden:NO];
                [addFile setHidden:NO];
                [toolbar setHidden:NO];
            } completion:^(BOOL finished){
                
            }];
            
            
        }else{
            
        }
    }else{
        if (show) {
            
        }else{
            [UIView animateWithDuration:0.3 animations:^{
                [backBtn setHidden:YES];
                [newbtn1 setHidden:YES];
                [addFile setHidden:YES];
                // [toolbar setHidden:YES];
            } completion:^(BOOL finished){
                
            }];
        }
    }
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	[tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    HTMLCell *cell = (HTMLCell *)[tableView cellForRowAtIndexPath:indexPath];
    if (isRootView == NO) {
        [backBtn setHidden:NO];
        [newbtn1 setHidden:NO];
        [addFile setHidden:NO];
        [newbtn setHidden:YES];
        
        if (cell.isFile) {
            if ([HTMLData canOpenThisKindOfFile:cell.filePath]) {
                //edit
                [self editCode:cell];
            }else if([HTMLData isImageFile:cell.filePath]){
                //image
                [self showImage:cell];
            }else if ([HTMLData isVideoFile:cell.filePath]){
                //play video
                [self playVideo:cell];
            }else if ([HTMLData isMusicFile:cell.filePath]){
                //play music
                [self playMusic:cell];
            }else if ([HTMLData isZipFile:cell.filePath]){
                //unzip
                [self unzip:cell];
            }
        }else{
            [UIView animateWithDuration:0.3 animations:^{
                for (UIView *view in [self.view subviews]) {
                    if (view.tag == 626) {
                        view.alpha = 0;
                    }
                    
                }
            } completion:^(BOOL finished){
                
                NSString *newPath = [nowPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:indexPath.row]];
                
                
                NSFileManager *manager = [NSFileManager defaultManager];
                [manager removeItemAtPath:[newPath stringByAppendingFormat:@"/tmpCL3275OpxuJS8tDBW844SD.html"] error:nil];
                
                self.fileList = [HTMLData fileList:newPath];
                
                [paths addObject:newPath];
                nowPath = [paths lastObject];
                
                if ([newPath isEqualToString:docPath]) {
                    [self showTool:NO backPath:docPath];
                    isRootView = YES;
                }else{
                    isRootView = NO;
                    [self showTool:YES backPath:oldPath];
                }
                [iPhoneTableView reloadData];
                
                [UIView animateWithDuration:0.3 animations:^{
                    for (UIView *view in [self.view subviews]) {
                        if (view == self.uploadFile) {
                            
                        }else{
                            view.alpha = 1;
                        }
                    }
                }];
            }];
        }
        
    }else{
        NSFileManager *manager = [NSFileManager defaultManager];
        BOOL isDir = NO;
        [manager fileExistsAtPath:cell.folderPath isDirectory:&isDir];
        if (isDir == NO) {
        }else{
            [backBtn setHidden:NO];
            [newbtn1 setHidden:NO];
            [addFile setHidden:NO];
            [newbtn setHidden:YES];
            [UIView animateWithDuration:0.3 animations:^{
                for (UIView *view in [self.view subviews]) {
                    if (view.tag == 626) {
                        view.alpha = 0;
                    }
                    
                }
            } completion:^(BOOL finished){
                
                NSString *newPath = [nowPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:indexPath.row]];
                
                
                
                [manager removeItemAtPath:[newPath stringByAppendingFormat:@"/tmpCL3275OpxuJS8tDBW844SD.html"] error:nil];
                
                self.fileList = [HTMLData fileList:newPath];
                
                [paths addObject:newPath];
                nowPath = [paths lastObject];
                
                if ([newPath isEqualToString:docPath]) {
                    [self showTool:NO backPath:docPath];
                    isRootView = YES;
                }else{
                    isRootView = NO;
                    [self showTool:YES backPath:oldPath];
                }
                [iPhoneTableView reloadData];
                
                [UIView animateWithDuration:0.3 animations:^{
                    for (UIView *view in [self.view subviews]) {
                        if (view == self.uploadFile) {
                            
                        }else{
                            view.alpha = 1;
                        }
                    }
                }];
            }];
        }
    }
    
}

- (void)editCode:(HTMLCell *)cell{
    HTMLEdit *editCode = [[HTMLEdit alloc] initWithNibName:@"HTMLEdit" bundle:nil];
    
    
    [codeinfo removeAllObjects];
    codeinfo = [[NSMutableDictionary alloc] init];
    [codeinfo setObject:[self.paths lastObject] forKey:@"folderPath"];
    [codeinfo setObject:cell.filename.text forKey:@"fileName"];
    [codeinfo setObject:cell.filePath forKey:@"filePath"];
    
    [myCode send];
    
    [UIView animateWithDuration:0.3 animations:^{
        for (UIView *view in [self.view subviews]) {
            view.alpha = 0;
            //[iPhoneTableView setUserInteractionEnabled:NO];
            
        }
    } completion:^(BOOL finished){
        
    }];
    [self presentViewController:editCode animated:NO completion:nil];
}

- (bool) GIFGetBytes:(int)length {
    if (GIF_buffer != nil)
    {
        GIF_buffer = nil;
    }
    
	if ((NSInteger)[GIF_pointer length] >= dataPointer + length) // Don't read across the edge of the file..
    {
		GIF_buffer = [NSMutableData dataWithData:[GIF_pointer subdataWithRange:NSMakeRange(dataPointer, length)]];
        dataPointer += length;
		return YES;
	}
    else
    {
        return NO;
	}
}


- (void) GIFReadExtensions {
	// 21! But we still could have an Application Extension,
	// so we want to check for the full signature.
	unsigned char cur[1], prev[1];
    [self GIFGetBytes:1];
    [GIF_buffer getBytes:cur length:1];
    
	while (cur[0] != 0x00)
    {
		
		// TODO: Known bug, the sequence F9 04 could occur in the Application Extension, we
		//       should check whether this combo follows directly after the 21.
		if (cur[0] == 0x04 && prev[0] == 0xF9)
		{
			[self GIFGetBytes:5];
            
			AnimatedGifFrame_ipad *frame = [[AnimatedGifFrame_ipad alloc] init];
			
			unsigned char buffer[5];
			[GIF_buffer getBytes:buffer length:5];
			frame.disposalMethod = (buffer[0] & 0x1c) >> 2;
			//NSLog(@"flags=%x, dm=%x", (int)(buffer[0]), frame.disposalMethod);
			
			// We save the delays for easy access.
			
			unsigned char board[8];
			board[0] = 0x21;
			board[1] = 0xF9;
			board[2] = 0x04;
			
			for(int i = 3, a = 0; a < 5; i++, a++)
			{
				board[i] = buffer[a];
			}
			
            
			[GIF_frames addObject:frame];
			break;
		}
		
		prev[0] = cur[0];
        [self GIFGetBytes:1];
		[GIF_buffer getBytes:cur length:1];
	}
}


- (NSData*) getFrameAsDataAtIndex:(int)index {
	if (index < (NSInteger)[GIF_frames count])
	{
		return ((AnimatedGifFrame_ipad *)[GIF_frames objectAtIndex:index]).data;
	}
	else
	{
		return nil;
	}
}

- (UIImage*) getFrameAsImageAtIndex:(int)index {
    NSData *frameData = [self getFrameAsDataAtIndex: index];
    UIImage *image = nil;
    
    if (frameData != nil)
    {
		image = [UIImage imageWithData:frameData];
    }
    
    return image;
}

- (bool) GIFSkipBytes: (int) length {
    if ((NSInteger)[GIF_pointer length] >= dataPointer + length)
    {
        dataPointer += length;
        return YES;
    }
    else
    {
    	return NO;
    }
}

- (void) decodeGIF:(NSData *)GIFData {
	GIF_pointer = GIFData;
    
    if (GIF_buffer != nil)
    {
        
    }
    
    if (GIF_global != nil)
    {
        
    }
    
    if (GIF_screen != nil)
    {
        
    }
    
    
	
    GIF_buffer = [[NSMutableData alloc] init];
	GIF_global = [[NSMutableData alloc] init];
	GIF_screen = [[NSMutableData alloc] init];
	GIF_frames = [[NSMutableArray alloc] init];
	
    // Reset file counters to 0
	dataPointer = 0;
	
	[self GIFSkipBytes: 6]; // GIF89a, throw away
	[self GIFGetBytes: 7]; // Logical Screen Descriptor
	
    // Deep copy
	[GIF_screen setData: GIF_buffer];
	
    // Copy the read bytes into a local buffer on the stack
    // For easy byte access in the following lines.
    int length = [GIF_buffer length];
	unsigned char aBuffer[length];
	[GIF_buffer getBytes:aBuffer length:length];
	
	if (aBuffer[4] & 0x80) GIF_colorF = 1; else GIF_colorF = 0;
	if (aBuffer[4] & 0x08) GIF_sorted = 1; else GIF_sorted = 0;
	GIF_colorC = (aBuffer[4] & 0x07);
	GIF_colorS = 2 << GIF_colorC;
	
	if (GIF_colorF == 1)
    {
		[self GIFGetBytes: (3 * GIF_colorS)];
        
        // Deep copy
		[GIF_global setData:GIF_buffer];
	}
	
	unsigned char bBuffer[1];
	while ([self GIFGetBytes:1] == YES)
    {
        [GIF_buffer getBytes:bBuffer length:1];
        
        if (bBuffer[0] == 0x3B)
        { // This is the end
            break;
        }
        
        switch (bBuffer[0])
        {
            case 0x21:
                // Graphic Control Extension (#n of n)
                [self GIFReadExtensions];
                break;
            case 0x2C:
                // Image Descriptor (#n of n)
                [self GIFReadDescriptor];
                break;
        }
	}
	
	// clean up stuff
    
    GIF_buffer = nil;
    
    
    GIF_screen = nil;
    
    
    GIF_global = nil;
}

- (void) GIFReadDescriptor {
	[self GIFGetBytes:9];
    
    // Deep copy
	NSMutableData *GIF_screenTmp = [NSMutableData dataWithData:GIF_buffer];
	
	unsigned char aBuffer[9];
	[GIF_buffer getBytes:aBuffer length:9];
	
	CGRect rect;
	rect.origin.x = ((int)aBuffer[1] << 8) | aBuffer[0];
	rect.origin.y = ((int)aBuffer[3] << 8) | aBuffer[2];
	rect.size.width = ((int)aBuffer[5] << 8) | aBuffer[4];
	rect.size.height = ((int)aBuffer[7] << 8) | aBuffer[6];
    
	AnimatedGifFrame_ipad *frame = [GIF_frames lastObject];
	frame.area = rect;
	
	if (aBuffer[8] & 0x80) GIF_colorF = 1; else GIF_colorF = 0;
	
	unsigned char GIF_code = GIF_colorC, GIF_sort = GIF_sorted;
	
	if (GIF_colorF == 1)
    {
		GIF_code = (aBuffer[8] & 0x07);
        
		if (aBuffer[8] & 0x20)
        {
            GIF_sort = 1;
        }
        else
        {
        	GIF_sort = 0;
        }
	}
	
	int GIF_size = (2 << GIF_code);
	
	size_t blength = [GIF_screen length];
	unsigned char bBuffer[blength];
	[GIF_screen getBytes:bBuffer length:blength];
	
	bBuffer[4] = (bBuffer[4] & 0x70);
	bBuffer[4] = (bBuffer[4] | 0x80);
	bBuffer[4] = (bBuffer[4] | GIF_code);
	
	if (GIF_sort)
    {
		bBuffer[4] |= 0x08;
	}
	
    NSMutableData *GIF_string = [NSMutableData dataWithData:[@"GIF89a" dataUsingEncoding: NSUTF8StringEncoding]];
	[GIF_screen setData:[NSData dataWithBytes:bBuffer length:blength]];
    [GIF_string appendData: GIF_screen];
    
	if (GIF_colorF == 1)
    {
		[self GIFGetBytes:(3 * GIF_size)];
		[GIF_string appendData:GIF_buffer];
	}
    else
    {
		[GIF_string appendData:GIF_global];
	}
	
	// Add Graphic Control Extension Frame (for transparancy)
	[GIF_string appendData:frame.header];
	
	char endC = 0x2c;
	[GIF_string appendBytes:&endC length:sizeof(endC)];
	
	size_t clength = [GIF_screenTmp length];
	unsigned char cBuffer[clength];
	[GIF_screenTmp getBytes:cBuffer length:clength];
	
	cBuffer[8] &= 0x40;
	
	[GIF_screenTmp setData:[NSData dataWithBytes:cBuffer length:clength]];
	
	[GIF_string appendData: GIF_screenTmp];
	[self GIFGetBytes:1];
	[GIF_string appendData: GIF_buffer];
	
	while (true)
    {
		[self GIFGetBytes:1];
		[GIF_string appendData: GIF_buffer];
		
		unsigned char dBuffer[1];
		[GIF_buffer getBytes:dBuffer length:1];
		
		long u = (long) dBuffer[0];
        
		if (u != 0x00)
        {
			[self GIFGetBytes:u];
			[GIF_string appendData: GIF_buffer];
        }
        else
        {
            break;
        }
        
	}
	
	endC = 0x3b;
	[GIF_string appendBytes:&endC length:sizeof(endC)];
	
	// save the frame into the array of frames
	frame.data = GIF_string;
}

- (void)showImage:(HTMLCell *)cell{
    BOOL git= NO;
    if ([[cell.filePath lowercaseString] hasSuffix:@".gif"]) {
        git = YES;
        [self decodeGIF:[NSData dataWithContentsOfFile:cell.filePath]];
        UIImage *firstImage = [self getFrameAsImageAtIndex:0];
        CGSize size = firstImage.size;
        NSString *html;
        if (size.width+1 > 270 && size.height+1 > 300) {
            html = [NSString stringWithFormat:@"<body><img src=\"%@\" /></body>",cell.filename.text];
        }else{
            html = [NSString stringWithFormat:@"<body><img src=\"%@\" height=\"%dpx\" width=\"%dpx\" /></body>",cell.filename.text,(int)size.height,(int)size.width];
        }

        [html writeToFile:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],@"/tmpCL3275OpxuJS8tDBW844SD.html"] atomically:YES encoding:NSUTF8StringEncoding error:nil];
        CGPoint point1;
        point1 = cell.frame.origin;
        CGPoint off = [iPhoneTableView contentOffset];
        point1.y = point1.y - off.y + 30;
        
        
        [HTMLShowGif showGifInView:self.view atPoint:point1 WithGifPath:cell.filePath andGifSize:size withURL:[NSURL URLWithString:[NSString stringWithFormat:@"%@/%@",[[self.paths lastObject] stringByReplacingOccurrencesOfString:@" " withString:@"%20"],@"/tmpCL3275OpxuJS8tDBW844SD.html"]] FromiPad:YES AndFolderPath:[self.paths lastObject]];
        
        /*
        UIWebView *gif = [[UIWebView alloc] initWithFrame:CGRectMake(0, 0, 600, 500)];
        for( UIView *view in [gif subviews] ) {
            if( [view isKindOfClass:[UIScrollView class]] ) {
                for( UIView *innerView in [view subviews] ) {
                    if( [innerView isKindOfClass:[UIImageView class]] ) {
                        innerView.hidden = YES;
                    }
                }
            }
        }
        if (size.width+1 > 660 || size.height+1 > 550) {
            [gif setScalesPageToFit:YES];
        }
        
        [gif setBackgroundColor:[UIColor whiteColor]];
        [gif loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:[NSString stringWithFormat:@"%@/%@",[self.paths lastObject],@"/tmpCL3275OpxuJS8tDBW844SD.html"]]]];
        [imageS setFrame:CGRectMake(0, 0, MIN(size.width+1, 600), MIN(size.height+1, 500))];
        [imageS addSubview:gif];
         
         [image1 setContentMode:UIViewContentModeScaleAspectFit];
         
         if (image1.image.size.width > 320 || image1.image.size.height > 480) {
         CGFloat bili = MAX(image1.image.size.width / 480.0, image1.image.size.height / 320.0);
         if (image1.image.size.width > image1.image.size.height) {
         bili = MAX(image1.image.size.width / 300.0, image1.image.size.height / 480.0);
         }
         bili = ceilf(bili);
         [imageS setFrame:CGRectMake(0, 0, image1.image.size.width/bili, image1.image.size.height/bili)];
         
         }else{
         [imageS setFrame:CGRectMake(0, 0, image1.image.size.width, image1.image.size.height)];
         }
         
         */
    }else{
        UIImage *theImage = [[UIImage alloc] initWithContentsOfFile:cell.filePath];
        photoPath = [NSString stringWithString:cell.filePath];
        image1.image = theImage;
        [imageS setFrame:CGRectMake(0, 0, 600, 500)];
        [imageS addSubview:image1];
        
        if (iPhone5) {
            CGPoint point1 = cell.frame.origin;
            CGPoint off = [iPhoneTableView contentOffset];
            point1.y = point1.y - off.y + 30;
            pv = [PopoverView showPopoverAtPoint:point1
                                          inView:self.view
                                 withContentView:imageS
                                        delegate:self];
        }else{
            CGPoint point1 = cell.frame.origin;
            CGPoint off = [iPhoneTableView contentOffset];
            point1.y = point1.y - off.y + 30;
            
            pv = [PopoverView showPopoverAtPoint:point1
                                          inView:self.view
                                 withContentView:imageS
                                        delegate:self];
        }
    }
    
    
    
}

- (void)setUpNotification{
    [[NSNotificationCenter defaultCenter]
     addObserver:self selector:@selector(updateTable) name:@"update" object:nil];
    [[NSNotificationCenter defaultCenter]
     addObserver:self selector:@selector(DropboxLinked) name:@"DropboxLinked" object:nil];
    [[NSNotificationCenter defaultCenter]
     addObserver:self selector:@selector(getOutFromDropbox) name:@"getOutFromDropbox" object:nil];
    [[NSNotificationCenter defaultCenter]
     addObserver:self selector:@selector(savedFromDropbox) name:@"savedFromDropbox" object:nil];
}

- (void)DropboxLinked{
    if ([[DBSession sharedSession] isLinked]) {
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            [self.dropbox setTitle:@"    退出链接    "  forState:UIControlStateNormal];
        }else{
            [self.dropbox setTitle:@"    Unlink    "  forState:UIControlStateNormal];
        }
    }else{
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            [self.dropbox setTitle:@"  链接Dropbox  "  forState:UIControlStateNormal];
        }else{
            [self.dropbox setTitle:@"     Link     "  forState:UIControlStateNormal];
        }
    }
    
    if (![[DBSession sharedSession] isLinked]) {
        self.dropboxFolder.enabled = NO;
        self.dropboxFolder.alpha = 0.7;
    }else{
        self.dropboxFolder.enabled = YES;
        self.dropboxFolder.alpha = 1.0;
    }
    
    SIAlertView *alert;
    if ([[HTMLData language] hasPrefix:@"zh"]) {
        alert = [[SIAlertView alloc] initWithTitle:@"提示" andMessage:@"成功链接Dropbox!"];
        [alert addButtonWithTitle:@"好的" type:SIAlertViewButtonTypeDestructive handler:nil];
        [alert show];
    }else{
        alert = [[SIAlertView alloc] initWithTitle:@"Tips" andMessage:@"Connect Dropbox Successfully! Now you can upload."];
        [alert addButtonWithTitle:@"OK" type:SIAlertViewButtonTypeDestructive handler:nil];
        [alert show];
    }
}

- (void)savedFromDropbox{
    self.fileList = [HTMLData fileList:[self.paths lastObject]];
    NSMutableArray *tmp = [[NSMutableArray alloc] init];
    for (NSString *file in self.fileList) {
        if ([file isEqualToString:@"tmpCL3275OpxuJS8tDBW844SD.html"]) {
            
        }else{
            [tmp addObject:file];
        }
    }
    self.fileList = tmp;
    [iPhoneTableView reloadData];
    
}

- (void)playVideo:(HTMLCell *)cell{
    NSURL *movieURL = [NSURL fileURLWithPath:cell.filePath];
    [moviePlayer setContentURL:movieURL];
    
    [moviePlayer.view setFrame:CGRectMake(0,0,660,400)];
    CGPoint point1;
    if (iPhone5) {
        point1 = cell.frame.origin;
        CGPoint off = [iPhoneTableView contentOffset];
        point1.y = point1.y - off.y + 30;
        
    }else{
        point1 = cell.frame.origin;
        CGPoint off = [iPhoneTableView contentOffset];
        point1.y = point1.y - off.y + 30;
        
    }
    [pv dismiss];
    [moviePlayer.view setBounds:CGRectMake(0,0,660,400)];
    
    [videoPop setTag:626];
    videoPop = [PopoverView showPopoverAtPoint:point1 inView:self.view withContentView:moviePlayer.view delegate:self];
    [moviePlayer play];
}

- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath{
    return YES;
}

- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    HTMLCell *cell = (HTMLCell *)[iPhoneTableView cellForRowAtIndexPath:indexPath];
    NSString *tmp;
    if (cell.isFile) {
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            tmp = @"文件";
        }else{
            tmp = @" file";
        }
    }else{
        if ([[HTMLData language]hasPrefix:@"zh"]) {
            tmp = @"文件夹";
        }else{
            tmp = @" folder";
        }
    }
    if (isRootView) {
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            tmp = @"工程";
        }else{
            tmp = @" project";
        }
        
    }
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        NSString *tilte = @"删除";
        NSString *msg = [NSString stringWithFormat:@"你确定要删除%@这个%@吗?",cell.filename.text,tmp];
        if ([[HTMLData language] hasPrefix:@"zh"]) {
            
        }else{
            tilte = @"Delete";
            msg = [NSString stringWithFormat:@"Are you sure to delete %@%@ ?",cell.filename.text,tmp];
        }
        
        
        SIAlertView *alert = [[SIAlertView alloc] initWithTitle:tilte andMessage:msg];
        if ([[HTMLData language]hasPrefix:@"zh"]) {
            [alert addButtonWithTitle:@"取消" type:SIAlertViewButtonTypeCancel handler:nil];
            [alert addButtonWithTitle:@"是的" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView) {
                NSMutableArray *tmp = [[NSMutableArray alloc] initWithArray:self.fileList];
                
                NSFileManager *manager = [NSFileManager defaultManager];
                NSString *path = [nowPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:indexPath.row]];
                NSError *error = nil;
                [manager removeItemAtPath:path error:&error];
                [tmp removeObjectAtIndex:indexPath.row];
                self.fileList = tmp;
                
                [iPhoneTableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
            }];
        }else{
            [alert addButtonWithTitle:@"Cancel" type:SIAlertViewButtonTypeCancel handler:nil];
            [alert addButtonWithTitle:@"YES" type:SIAlertViewButtonTypeDestructive handler:^(SIAlertView *alertView) {
                NSMutableArray *tmp = [[NSMutableArray alloc] initWithArray:self.fileList];
                
                NSFileManager *manager = [NSFileManager defaultManager];
                NSString *path = [nowPath stringByAppendingFormat:@"/%@",[self.fileList objectAtIndex:indexPath.row]];
                NSError *error = nil;
                [manager removeItemAtPath:path error:&error];
                [tmp removeObjectAtIndex:indexPath.row];
                self.fileList = tmp;
                
                [iPhoneTableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
            }];
        }
        [alert show];
    }
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
    }
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
	return 64;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return [self.fileList count];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation

{
    return YES;
    
}

- (BOOL)shouldAutorotate

{
    
    return YES;
    
}

- (void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:animated];
    [[UIApplication sharedApplication] endReceivingRemoteControlEvents];
}

- (BOOL) canBecomeFirstResponder {
    return YES;
}

- (NSUInteger)supportedInterfaceOrientations

{
    return UIInterfaceOrientationMaskLandscape;
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
